SystemOrganization addCategory: #Scriptaculous!
SystemOrganization addCategory: #'Scriptaculous-Core'!
SystemOrganization addCategory: #'Scriptaculous-Testing'!

WAComponent subclass: #SUExample
	instanceVariableNames: 'text classname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUExample class methodsFor: 'testing' stamp: 'lr 2/14/2006 12:17'!
canBeRoot
	^ true! !

!SUExample class methodsFor: 'initialization' stamp: 'lr 2/14/2006 12:19'!
initialize
	(self registerAsApplication: 'scriptaculous')
		libraries add: SUScriptLibrary.! !

!SUExample methodsFor: 'as yet unclassified' stamp: 'lr 2/22/2006 01:07'!
renderContentOn: html
	html div id: 'fade-next'; with:
		[html anchor callback: [self session effect fade id: 'fade-next']; text: 'Fade next time'].
			
	self renderDragDropOn: html.
	
	20 timesRepeat: [html break].
	html anchor
		id: 'scroll';
		callback: [ self session effect scrollTo id: 'scroll'];
		text: 'scroll here'.
	20 timesRepeat: [html break]! !

!SUExample methodsFor: 'as yet unclassified' stamp: 'lr 2/14/2006 21:28'!
renderDragDropOn: html
	1 to: 5 do: [ :each |
		html span
			class: 'drag';
			script: (html draggable
				passenger: each;
				revert);
			with: 'Drag' , each asString.
		html space ].

	html div
		script: (html droppable 
			accept: 'drag';
			onHover: (html ajax 
				id: 'hover';
				callback: [ :v :r | r render: v ]);
			onDrop: (html ajax 
				id: 'drop';
				callback: [ :v :r | r render: v ]));
		with: 'Drop'.

	html div id: 'hover'; with: 'hover'.
	html div id: 'drop'; with: 'drop'.! !

!SUExample methodsFor: 'as yet unclassified' stamp: 'avi 9/21/2005 22:47'!
rendererClass 
	^ WARenderCanvas! !

WAComponent subclass: #SUFunctionalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

SUFunctionalTest subclass: #SUAutocompleteTest
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUAutocompleteTest methodsFor: 'rendering' stamp: 'dc 3/2/2006 11:19'!
renderContentOn: html
	html paragraph: 'Start typing some class name:'.
	html form: [
		html textInput
			value: text;
			callback: [ :value | text := value ];
			script: ((html autocomplete: 'name')
				on: #renderListOn: of: self).
		html div 
			id: 'name';
			class: 'autocomplete' ].! !

!SUAutocompleteTest methodsFor: 'rendering' stamp: 'lr 3/1/2006 21:31'!
renderListOn: html
	html unorderedList list: (Smalltalk allClasses
		select: [ :each | each name includesSubString: text ]).! !

!SUAutocompleteTest methodsFor: 'rendering' stamp: 'lr 2/22/2006 00:12'!
style
	^  'div.autocomplete {
	position: absolute;
	background-color: white;
	border: 1px solid gray;
	margin: 0px;
	padding: 0px;
}
div.autocomplete ul {
	list-style-type: none;
	margin: 0px;
	padding: 0px;
}
div.autocomplete ul li.selected {
	background-color: orange;
}
div.autocomplete ul li {
	list-style-type: none;
	display: block;
	margin: 0px;
	padding: 1px;
}'! !

SUFunctionalTest subclass: #SUCounterTest
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUCounterTest methodsFor: 'actions' stamp: 'lr 2/22/2006 00:40'!
decrease
	count := count - 1.! !

!SUCounterTest methodsFor: 'actions' stamp: 'lr 2/22/2006 00:40'!
increase
	count := count + 1.! !

!SUCounterTest methodsFor: 'initilization' stamp: 'lr 2/22/2006 00:40'!
initialize
	super initialize.
	count := 0.! !

!SUCounterTest methodsFor: 'rendering' stamp: 'lr 3/1/2006 21:33'!
renderContentOn: html
	html heading
		id: 'count';
		with: count.
	html anchor
		onClick: (html ajax
			id: 'count';
			callback: [ :render | self increase; renderCountOn: html ]);
		ignoreURL;
		text: '++'.
	html space.
	html anchor
		onClick: (html ajax
			id: 'count';
			callback: [ :render | self decrease; renderCountOn: html ]);
		ignoreURL;
		text: '--'.! !

!SUCounterTest methodsFor: 'rendering' stamp: 'lr 2/22/2006 00:40'!
renderCountOn: html
	html render: count.! !

SUFunctionalTest subclass: #SUEffectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUEffectTest methodsFor: 'accessing' stamp: 'lr 2/21/2006 22:26'!
effects
	^ #( appear fade puff blindDown blindUp switchOff slideDown slideUp dropOut shake pulsate squish fold grow shrink highlight )! !

!SUEffectTest methodsFor: 'rendering' stamp: 'lr 2/22/2006 00:20'!
renderContentOn: html
	self renderEffects: self effects labelled: 'Effects' on: html.
	self renderEffects: self toggles labelled: 'Toggles' on: html.
	self renderExampleOn: html.! !

!SUEffectTest methodsFor: 'rendering' stamp: 'lr 2/22/2006 00:20'!
renderEffects: aCollection labelled: aString on: html
	html bold: aString; text: ': '.
	aCollection
		do: [ :each |
			html anchor
				onClick: (html effect
					id: 'example';
					perform: each);
				ignoreURL;
				text: each ]
		separatedBy: [ html text: ' ' ].
	html break.! !

!SUEffectTest methodsFor: 'rendering' stamp: 'lr 2/22/2006 00:21'!
renderExampleOn: html
	html break.
 	html div
		id: 'example';
		with: [ 
			html div
				id: 'contents';
 				with: 'Seaside Aubergines' ].! !

!SUEffectTest methodsFor: 'rendering' stamp: 'lr 2/22/2006 00:14'!
style
	^ 'div#example { background-color: orange; }
div#contents { height: 1.25em; font-size: 400%; text-align: center; }'! !

!SUEffectTest methodsFor: 'accessing' stamp: 'lr 2/21/2006 23:38'!
toggles
	^ #( toggleAppear toggleBlind toggleSlide )! !

SUFunctionalTest subclass: #SUFormTest
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUFormTest methodsFor: 'rendering' stamp: 'lr 3/1/2006 21:35'!
renderContentOn: html
	html textInput 
		id: 'element';
		callback: [ :value | text := value ].
	html anchor
		onClick: (html ajax
			id: 'text';
			triggerCallbackFor: 'element';
			on: #renderTextOn: of: self);
		ignoreURL;
		text: 'reverse'.
	html div id: 'text'.
	html break.! !

!SUFormTest methodsFor: 'rendering' stamp: 'lr 3/1/2006 21:34'!
renderTextOn: html
	html render: text reverse.! !

!SUFunctionalTest methodsFor: 'private' stamp: 'lr 2/22/2006 10:12'!
logEvent: aString on: html 
	^ html ajax
		id: 'logger'; 
		insertBottom;
		callback: [ :renderer | self renderLogEvent: aString on: renderer ].! !

!SUFunctionalTest methodsFor: 'accessing' stamp: 'lr 2/21/2006 20:56'!
rendererClass 
	^ WARenderCanvas! !

!SUFunctionalTest methodsFor: 'rendering' stamp: 'lr 2/22/2006 10:12'!
renderLogEvent: aString on: html
	html render: Time now; text: ' - '; render: aString; break.! !

SUFunctionalTest subclass: #SUInsertTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUInsertTest methodsFor: 'rendering' stamp: 'lr 3/1/2006 21:42'!
renderContentOn: html
	#( insertBefore insertTop insertBottom insertAfter ) do: [ :each |
		html anchor
			onClick: (html ajax 
				id: 'element';
				perform: each;
				on: #renderElementOn: of: self);
			ignoreURL;
			text: each.
		html break ].
	html break.
	html div 
		id: 'element'; 
		with: 'Element'.! !

!SUInsertTest methodsFor: 'rendering' stamp: 'lr 3/1/2006 21:41'!
renderElementOn: html
	html div: Time now.! !

!SUInsertTest methodsFor: 'rendering' stamp: 'lr 2/22/2006 00:36'!
style
	^ 'div#element { background-color: orange; }'! !

SUFunctionalTest subclass: #SUPeriodicalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUPeriodicalTest methodsFor: 'rendering' stamp: 'lr 3/1/2006 21:41'!
renderContentOn: html
	html div
		script: (html periodical on: #renderTimeOn: of: self);
		with: [ self renderTimeOn: html ].! !

!SUPeriodicalTest methodsFor: 'rendering' stamp: 'lr 2/22/2006 00:22'!
renderTimeOn: html
	html render: Time now.! !

SUFunctionalTest subclass: #SUSortableTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUSortableTest methodsFor: 'accessing' stamp: 'lr 2/22/2006 15:17'!
elements
	^ (1 to: 7) collect: [ :each | 'Element ' , each asString ].! !

!SUSortableTest methodsFor: 'rendering' stamp: 'dc 3/2/2006 11:20'!
renderContentOn: html
	| sortable |
	html paragraph: 'Drag and drop the elements:'.
	html unorderedList
		id: 'list';
		script: (sortable := html sortable
			onUpdate: (html ajax
				id: 'status';
				addParameter: (html sortable id: 'list'; serialize);
				callback: [ :r | r orderedList list: (sortable transform: self elements) ]));
		with: [
			self elements withIndexDo: [ :each :index |
				html listItem
					id: 'item_' , index asString;
					with: each ] ].
	html div id: 'status'.! !

!SUSortableTest methodsFor: 'rendering' stamp: 'lr 2/22/2006 15:27'!
style
	^ '#list li { cursor: move; }'! !

!Object methodsFor: '*scriptaculous' stamp: 'avi 6/30/2005 13:55'!
asJavascript
	^ self printString! !

Object subclass: #SUJavascript
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUJavascript class methodsFor: 'instance-creation' stamp: 'lr 2/21/2006 20:44'!
function: anObject
	^ self on: 'function() { ' , anObject asJavascript , ' }'.! !

!SUJavascript class methodsFor: 'instance-creation' stamp: 'lr 2/21/2006 20:41'!
on: aString
	^ self new 
		source: aString;
		yourself.! !

!SUJavascript methodsFor: 'converting' stamp: 'lr 2/21/2006 20:38'!
asJavascript
	^ self source! !

!SUJavascript methodsFor: 'accessing' stamp: 'lr 2/21/2006 20:38'!
source
	^ source! !

!SUJavascript methodsFor: 'accessing' stamp: 'lr 2/21/2006 20:38'!
source: aString
	source := aString! !

Object subclass: #SUJoin
	instanceVariableNames: 'collection joiner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUJoin class methodsFor: 'instance-creation' stamp: 'avi 9/27/2005 23:29'!
join: aCollection with: aString
	^ self new
		collection: aCollection;
		joiner: aString;
		yourself! !

!SUJoin methodsFor: 'converting' stamp: 'avi 9/27/2005 23:29'!
asJavascript
	^ String streamContents:
		[:s |
		s
			nextPutAll: collection asJavascript;
			nextPutAll: '.join(';
			nextPutAll: joiner asJavascript;
			nextPutAll: ')']! !

!SUJoin methodsFor: 'accessing' stamp: 'avi 9/27/2005 23:40'!
collection
	^ collection! !

!SUJoin methodsFor: 'accessing' stamp: 'avi 9/27/2005 23:28'!
collection: aCollection
	collection _ aCollection! !

!SUJoin methodsFor: 'accessing' stamp: 'avi 9/27/2005 23:40'!
joiner
	^ joiner! !

!SUJoin methodsFor: 'accessing' stamp: 'avi 9/27/2005 23:28'!
joiner: aString
	joiner _ aString! !

Object subclass: #SUPrototype
	instanceVariableNames: 'effect id args options before after'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

SUPrototype subclass: #SUAjax
	instanceVariableNames: 'renderBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUAjax methodsFor: 'as yet unclassified' stamp: 'avi 9/27/2005 23:38'!
addParameters: aCollection
	self parameters addAll: aCollection associations! !

!SUAjax methodsFor: 'as yet unclassified' stamp: 'avi 9/27/2005 23:39'!
addParameter: anAssociation
	self parameters add: anAssociation! !

!SUAjax methodsFor: 'options' stamp: 'lr 2/25/2006 13:12'!
asynchronous: aBoolean
	"Indicates if the AJAX call will be made asynchronously."

	self optionAt: 'asynchronous' put: aBoolean.! !

!SUAjax methodsFor: 'effects' stamp: 'lr 2/25/2006 13:19'!
autocomplete: aString
	self args: (Array with: aString) , self args.
	self effect: 'Autocompleter'.! !

!SUAjax methodsFor: 'as yet unclassified' stamp: 'avi 9/21/2005 22:48'!
callback: aBlock
	renderBlock _ aBlock! !

!SUAjax methodsFor: 'private' stamp: 'avi 6/30/2005 13:50'!
defaultEffect
	^ 'Updater'! !

!SUAjax methodsFor: 'options-insertion' stamp: 'lr 2/25/2006 13:18'!
insertAfter
	"Insert content after an element."

	self insert: 'After'.! !

!SUAjax methodsFor: 'options-insertion' stamp: 'lr 2/25/2006 13:17'!
insertBefore
	"Insert content before an element."

	self insert: 'Before'.! !

!SUAjax methodsFor: 'options-insertion' stamp: 'lr 2/25/2006 13:18'!
insertBottom
	"Insert content as the last child under an element, right before the element's closing tag."

	self insert: 'Bottom'.! !

!SUAjax methodsFor: 'options-insertion' stamp: 'lr 2/25/2006 13:17'!
insertTop
	"Insert the content as the first child under an element, right after the opening tag of the element."

	self insert: 'Top'.! !

!SUAjax methodsFor: 'options' stamp: 'lr 2/25/2006 13:14'!
insert: aString
	"Option to be used to inject the returned text into an element."

	self optionAt: 'insertion' put: (SUJavascript on: 'Insertion.' , aString).! !

!SUAjax methodsFor: 'events' stamp: 'lr 2/22/2006 09:57'!
onComplete: aPrototype
	"Called when the XMLHttpRequest is complete (fires after success/failure, if they are present)."

	self optionAt: 'onComplete' put: (SUJavascript function: aPrototype).! !

!SUAjax methodsFor: 'events' stamp: 'lr 2/22/2006 09:57'!
onFailure: aPrototype
	"Called when the XMLHttpRequest is completed, and the HTTP status code is not in the 2XX range."

	self optionAt: 'onFailure' put: (SUJavascript function: aPrototype).! !

!SUAjax methodsFor: 'events' stamp: 'lr 2/22/2006 09:57'!
onInteractive: aPrototype
	"Called when the user can interact with the remote document, even though it has not finished loading."

	self optionAt: 'onInteractive' put: (SUJavascript function: aPrototype).! !

!SUAjax methodsFor: 'events' stamp: 'lr 2/22/2006 09:58'!
onLoaded: aPrototype
	"Called when the browser has finished loading the remote document."

	self optionAt: 'onLoaded' put: (SUJavascript function: aPrototype).! !

!SUAjax methodsFor: 'events' stamp: 'lr 2/22/2006 09:58'!
onLoading: aPrototype
	"Called when the remote document is being loaded with data by the browser."

	self optionAt: 'onLoading' put: (SUJavascript function: aPrototype).! !

!SUAjax methodsFor: 'events' stamp: 'lr 2/22/2006 09:58'!
onSuccess: aPrototype
	"Called when the XMLHttpRequest is completed, and the HTTP status code is in the 2XX range."

	self optionAt: 'onSuccess' put: (SUJavascript function: aPrototype).! !

!SUAjax methodsFor: 'as yet unclassified' stamp: 'lr 2/14/2006 17:19'!
on: aSelector of: anObject
	renderBlock := MessageSend receiver: anObject selector: aSelector! !

!SUAjax methodsFor: 'as yet unclassified' stamp: 'avi 9/27/2005 23:39'!
parameters
	^ (self options at: 'parameters' ifAbsentPut: (SUJoin join: OrderedCollection new with: '&'))
		collection! !

!SUAjax methodsFor: 'as yet unclassified' stamp: 'avi 9/21/2005 22:49'!
renderOn: html
	renderBlock value: html! !

!SUAjax methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2006 00:35'!
triggerCallbackFor: idString
	self addParameter:
		(SUFormElement new
			id: idString;
			serialize)! !

!SUAjax methodsFor: 'private' stamp: 'avi 6/30/2005 13:47'!
type
	^ 'Ajax'! !

!SUAjax methodsFor: 'as yet unclassified' stamp: 'avi 9/27/2005 23:53'!
url: aURL
	self args: (Array with: aURL urlString).
	self addParameters: aURL parameters! !

SUAjax subclass: #SUAutocompleter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUAutocompleter methodsFor: 'private' stamp: 'lr 3/1/2006 21:22'!
defaultEffect
	^ 'Autocompleter'! !

!SUAutocompleter methodsFor: 'options' stamp: 'lr 3/1/2006 21:23'!
frequency: aNumber
	self optionAt: 'frequency' put: aNumber.! !

!SUAutocompleter methodsFor: 'options' stamp: 'lr 3/1/2006 21:23'!
minChars: aNumber
	self optionAt: 'minChars' put: aNumber.! !

!SUAutocompleter methodsFor: 'initialization' stamp: 'lr 3/1/2006 21:28'!
setTarget: aString
	self args: (Array with: aString) , self args.! !

!SUAutocompleter methodsFor: 'options' stamp: 'lr 3/1/2006 21:28'!
tokens: anArray
	self optionAt: 'tokens' put: anArray.! !

SUAjax subclass: #SUPeriodicalUpdater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUPeriodicalUpdater methodsFor: 'options' stamp: 'lr 3/1/2006 21:10'!
decay: aNumber
	"Determines the progressive slowdown in a PeriodicalUpdater object refresh rate when the received response is the same as the last one. For example, if you use 2, after one of the refreshes produces the same result as the previous one, the object will wait twice as much time for the next refresh. If it repeats again, the object will wait four times as much, and so on. Leave it undefined or use 1 to avoid the slowdown."

	self optionAt: 'decay' put: aNumber.! !

!SUPeriodicalUpdater methodsFor: 'private' stamp: 'lr 3/1/2006 21:11'!
defaultEffect
	^ 'PeriodicalUpdater'! !

!SUPeriodicalUpdater methodsFor: 'options' stamp: 'lr 3/1/2006 21:10'!
frequency: aNumber
	"Interval (not frequency) between refreshes, in seconds. This number will be multiplied by the current decay."

	self optionAt: 'frequency' put: aNumber.! !

SUPrototype subclass: #SUDraggable
	instanceVariableNames: 'passenger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUDraggable methodsFor: 'private' stamp: 'lr 2/14/2006 21:35'!
attachToBrush: aBrush on: aCanvas
	super attachToBrush: aBrush on: aCanvas.
	aCanvas context callbacks at: id put: self passenger.! !

!SUDraggable methodsFor: 'options' stamp: 'lr 2/14/2006 14:44'!
constraintHorizontal
	self constraint: 'horizontal'! !

!SUDraggable methodsFor: 'options' stamp: 'lr 2/14/2006 14:44'!
constraintVertical
	self constraint: 'vertical'! !

!SUDraggable methodsFor: 'options' stamp: 'lr 2/14/2006 14:44'!
constraint: aString
	"If set to 'horizontal' or 'vertical' the drag will be constrained to take place only horizontally or vertically."

	self optionAt: 'constraint' put: aString! !

!SUDraggable methodsFor: 'options' stamp: 'lr 2/14/2006 14:43'!
ghosting: aBoolean
	"Clones the element and drags the clone, leaving the original in place until the clone is dropped."

	self optionAt: 'ghosting' put: aBoolean! !

!SUDraggable methodsFor: 'options' stamp: 'lr 2/14/2006 15:57'!
handle: aString
	"Sets whether the element should only be draggable by an embedded handle. The value must be an element reference or element id."

	self optionAt: 'handle' put: aString! !

!SUDraggable methodsFor: 'accessing' stamp: 'lr 2/14/2006 15:56'!
passenger
	^ passenger! !

!SUDraggable methodsFor: 'accessing' stamp: 'lr 2/14/2006 15:56'!
passenger: anObject
	passenger := anObject! !

!SUDraggable methodsFor: 'options' stamp: 'lr 2/14/2006 14:42'!
revert: aBoolean
	"If set to true, the element returns to its original position when the drags ends."

	self optionAt: 'revert' put: aBoolean! !

!SUDraggable methodsFor: 'options' stamp: 'lr 2/14/2006 17:11'!
snap: aBooleanOrPoint
	"If set to false no snapping occurs. Otherwise takes the forms [x,y]."

	self optionAt: 'snap' put: aBooleanOrPoint! !

!SUDraggable methodsFor: 'private' stamp: 'avi 6/22/2005 16:41'!
type
	^ 'Draggable'! !

!SUDraggable methodsFor: 'options' stamp: 'lr 2/14/2006 15:58'!
zindex: anInteger
	"The css zindex of the draggable item."

	self optionAt: 'zindex' put: anInteger! !

SUPrototype subclass: #SUDroppable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUDroppable methodsFor: 'options' stamp: 'lr 2/14/2006 15:01'!
accept: aStringOrArray
	"Set accept to a string or an array of strings describing CSS classes. The Droppable will only accept Draggables that have one or more of these CSS classes."

	self optionAt: 'accept' put: aStringOrArray.! !

!SUDroppable methodsFor: 'options' stamp: 'lr 2/14/2006 15:00'!
containment: aStringOrArray
	"The droppable will only accept the Draggable if the Draggable is contained in the given elements (or element ids). Can be a single element or an array of elements."

	self optionAt: 'containment' put: aStringOrArray.! !

!SUDroppable methodsFor: 'private' stamp: 'lr 2/14/2006 13:54'!
defaultEffect
	^ 'add'! !

!SUDroppable methodsFor: 'options' stamp: 'lr 2/14/2006 15:01'!
greedy: aBoolean
	"If true stops processing hovering (don't look for other Droppables that are under the Draggable)."

	self optionAt: 'greedy' put: aBoolean! !

!SUDroppable methodsFor: 'options' stamp: 'lr 2/14/2006 13:59'!
hoverclass: aString
	"If set, the Droppable will have this additional CSS class when an accepted Draggable is hovered over it."

	self optionAt: 'hoverclass' put: aString! !

!SUDroppable methodsFor: 'callbacks' stamp: 'lr 2/14/2006 21:01'!
onDrop: aPrototype
	"Called whenever a Draggable is released over the Droppable and the Droppable is accepts it. The callback gets two parameters: the Draggable element, and the Droppable element."

	aPrototype addParameter: '_t' -> (SUEval on: '_t.id').
	self optionAt: 'onDrop' put: (SUEval on: 'function(_t) {' , aPrototype asJavascript , '}').! !

!SUDroppable methodsFor: 'callbacks' stamp: 'lr 2/14/2006 21:15'!
onHover: aPrototype
	"Called whenever a Draggable is moved over the Droppable and the Droppable is affected (would accept it). The callback gets three parameters: the Draggable, the Droppable element, and the percentage of overlapping as defined by the overlap option."

	aPrototype addParameter: '_t' -> (SUEval on: '_t.id').
	self optionAt: 'onHover' put: (SUEval on: 'function(_t) {' , aPrototype asJavascript , '}').! !

!SUDroppable methodsFor: 'options' stamp: 'lr 2/14/2006 13:58'!
overlapHorizontal
	self overlap: 'horizontal'! !

!SUDroppable methodsFor: 'options' stamp: 'lr 2/14/2006 13:58'!
overlapVertical
	self overlap: 'vertical'! !

!SUDroppable methodsFor: 'options' stamp: 'lr 2/14/2006 13:59'!
overlap: aString
	"If set to 'horizontal' or 'vertical' the droppable will only react to a Draggable if its overlapping by more than 50% in the given direction."

	self optionAt: 'overlap' put: aString! !

!SUDroppable methodsFor: 'private' stamp: 'lr 2/14/2006 13:52'!
shouldCreateInstance
	^ false! !

!SUDroppable methodsFor: 'private' stamp: 'lr 2/14/2006 13:52'!
type
	^ 'Droppables'! !

SUPrototype subclass: #SUEffect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUEffect methodsFor: 'effects' stamp: 'avi 6/22/2005 16:21'!
appear
	self effect: 'Appear'! !

!SUEffect methodsFor: 'effects' stamp: 'avi 6/22/2005 16:22'!
blindDown
	self effect: 'BlindDown'! !

!SUEffect methodsFor: 'effects' stamp: 'avi 6/22/2005 16:22'!
blindUp
	self effect: 'BlindUp'! !

!SUEffect methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:21'!
defaultEffect
	^ 'Fade'! !

!SUEffect methodsFor: 'effects' stamp: 'lr 2/21/2006 22:26'!
dropOut
	self effect: 'DropOut'! !

!SUEffect methodsFor: 'options' stamp: 'lr 2/21/2006 22:06'!
duration: aNumber
	"Duration of the effect in seconds, given as a float. Defaults to 1.0."

	self optionAt: 'duration' put: aNumber.! !

!SUEffect methodsFor: 'effects' stamp: 'avi 6/22/2005 16:21'!
fade
	self effect: 'Fade'! !

!SUEffect methodsFor: 'effects' stamp: 'lr 2/21/2006 22:27'!
fold
	self effect: 'Fold'! !

!SUEffect methodsFor: 'options' stamp: 'lr 2/21/2006 22:06'!
fps: aNumber
	"Target this many frames per second. Default to 25. Cant be higher than 100."

	self optionAt: 'fps' put: aNumber.! !

!SUEffect methodsFor: 'options' stamp: 'lr 2/21/2006 22:06'!
from: aNumber
	"Sets the starting point of the transition, a float between 0.0 and 1.0. Defaults to 0.0."

	self optionAt: 'from' put: aNumber.! !

!SUEffect methodsFor: 'effects' stamp: 'lr 2/21/2006 22:27'!
grow
	self effect: 'Grow'! !

!SUEffect methodsFor: 'effects' stamp: 'avi 9/21/2005 22:58'!
highlight
	self effect: 'Highlight'! !

!SUEffect methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:19'!
moveBy
	self effect: 'MoveBy'! !

!SUEffect methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:20'!
moveBy: aPoint
	self moveBy; args: (Array with: aPoint x with: aPoint y)! !

!SUEffect methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:18'!
opacity
	self effect: 'Opacity'! !

!SUEffect methodsFor: 'effects' stamp: 'avi 6/22/2005 16:21'!
puff
	self effect: 'Puff'! !

!SUEffect methodsFor: 'effects' stamp: 'lr 2/21/2006 22:26'!
pulsate
	self effect: 'Pulsate'! !

!SUEffect methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:19'!
scale
	self effect: 'Scale'! !

!SUEffect methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:19'!
scale: aNumber
	self scale; args: (Array with: aNumber)! !

!SUEffect methodsFor: 'as yet unclassified' stamp: 'avi 9/24/2005 19:35'!
scrollTo
	self effect: 'ScrollTo'! !

!SUEffect methodsFor: 'effects' stamp: 'lr 2/21/2006 22:26'!
shake
	self effect: 'Shake'! !

!SUEffect methodsFor: 'effects' stamp: 'lr 2/21/2006 22:27'!
shrink
	self effect: 'Shrink'! !

!SUEffect methodsFor: 'effects' stamp: 'avi 6/22/2005 16:22'!
slideDown
	self effect: 'SlideDown'! !

!SUEffect methodsFor: 'effects' stamp: 'avi 6/22/2005 16:22'!
slideUp
	self effect: 'SlideUp'! !

!SUEffect methodsFor: 'effects' stamp: 'lr 2/21/2006 22:27'!
squish
	self effect: 'Squish'! !

!SUEffect methodsFor: 'effects' stamp: 'avi 6/22/2005 16:21'!
switchOff
	self effect: 'SwitchOff'! !

!SUEffect methodsFor: 'toggles' stamp: 'lr 2/21/2006 23:36'!
toggleAppear
	self toggle: 'appear'.! !

!SUEffect methodsFor: 'toggles' stamp: 'lr 2/21/2006 23:36'!
toggleBlind
	self toggle: 'blind'.! !

!SUEffect methodsFor: 'toggles' stamp: 'lr 2/21/2006 23:36'!
toggleSlide
	self toggle: 'slide'.! !

!SUEffect methodsFor: 'toggles' stamp: 'lr 2/21/2006 23:41'!
toggle: aString
	self effect: 'toggle'; args: (Array with: aString).! !

!SUEffect methodsFor: 'options' stamp: 'lr 2/21/2006 22:07'!
to: aNumber
	"Sets the end point of the transition, a float between 0.0 and 1.0. Defaults to 1.0."

	self optionAt: 'to' put: aNumber.! !

!SUEffect methodsFor: 'as yet unclassified' stamp: 'avi 9/21/2005 22:57'!
type
	^ 'Effect'! !

SUPrototype subclass: #SUElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUElement methodsFor: 'as yet unclassified' stamp: 'avi 9/24/2005 19:31'!
defaultEffect
	^ 'toggle'! !

!SUElement methodsFor: 'as yet unclassified' stamp: 'avi 9/24/2005 19:31'!
hide
	self effect: 'hide'! !

!SUElement methodsFor: 'as yet unclassified' stamp: 'avi 9/24/2005 19:31'!
remove
	self effect: 'remove'! !

!SUElement methodsFor: 'as yet unclassified' stamp: 'avi 9/24/2005 19:31'!
shouldCreateInstance
	^ false! !

!SUElement methodsFor: 'as yet unclassified' stamp: 'avi 9/24/2005 19:31'!
show
	self effect: 'show'! !

!SUElement methodsFor: 'as yet unclassified' stamp: 'avi 9/24/2005 19:31'!
toggle
	self effect: 'toggle'! !

!SUElement methodsFor: 'as yet unclassified' stamp: 'avi 9/27/2005 23:54'!
type
	^ 'Element'! !

SUPrototype subclass: #SUFormElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUFormElement methodsFor: 'as yet unclassified' stamp: 'avi 9/27/2005 23:22'!
defaultEffect
	^ 'getValue'! !

!SUFormElement methodsFor: 'as yet unclassified' stamp: 'avi 9/27/2005 23:22'!
getValue
	self effect: 'getValue'! !

!SUFormElement methodsFor: 'as yet unclassified' stamp: 'avi 9/27/2005 23:22'!
serialize
	self effect: 'serialize'! !

!SUFormElement methodsFor: 'as yet unclassified' stamp: 'avi 9/27/2005 23:21'!
shouldCreateInstance
	^ false! !

!SUFormElement methodsFor: 'as yet unclassified' stamp: 'avi 9/27/2005 23:54'!
type
	^ 'Form.Element'! !

!SUPrototype methodsFor: 'accessing' stamp: 'lr 2/22/2006 06:49'!
after: aPrototype
	"Called immediately after the request was initated."

	after := aPrototype! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:16'!
args
	^ args ifNil: [self defaultArgs]! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 15:52'!
args: aCollection
	args _ aCollection! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'lr 2/22/2006 16:57'!
attachToBrush: aBrush on: aCanvas
	self id: aBrush ensureId.
	self session addLoadScript: self.! !

!SUPrototype methodsFor: 'accessing' stamp: 'lr 2/22/2006 06:49'!
before: aPrototype
	"Called directly before the request is initated."

	before := aPrototype! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:16'!
defaultArgs
	^ #()! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:38'!
defaultEffect
	^ ''! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:14'!
effect
	^ effect ifNil: [self defaultEffect]! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 15:51'!
effect: aString
	effect _ aString! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:15'!
idString
	^ id ifNil:['this'] ifNotNil: [id printString]! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 15:52'!
id: aString
	id _ aString! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'lr 2/11/2006 23:56'!
optionAt: key put: value
	self options at: key put: value.! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 15:52'!
options
	^ options ifNil: [options _ Dictionary new]! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 2/22/2006 14:12'!
printAfterOn: aStream
	after ifNotNil: [ aStream nextPutAll: '; '; nextPutAll: after asJavascript ].! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 2/22/2006 14:12'!
printArgsOn: aStream
	self args do: [ :each | aStream nextPutAll: ', '; nextPutAll: each printString ].! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 2/22/2006 14:12'!
printBeforeOn: aStream
	before ifNotNil: [ aStream nextPutAll: before asJavascript; nextPutAll: '; ' ].! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 2/22/2006 14:10'!
printEffectOn: aStream
	self effect isEmpty ifFalse: [ aStream nextPut: $.; nextPutAll: self effect ].! !

!SUPrototype methodsFor: 'printing' stamp: 'lr 2/22/2006 14:09'!
printOn: aStream
	self 
		printBeforeOn: aStream; 
		printTypeOn: aStream; 
		printEffectOn: aStream;
		printParamsOn: aStream;
		printAfterOn: aStream.! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 2/22/2006 17:00'!
printOptionsOn: aStream
	self options isEmpty ifFalse: [
		aStream nextPutAll: ', {'.
		self options associations
			do: [ :assoc | aStream nextPutAll: assoc key; nextPutAll: ': '; nextPutAll: assoc value asJavascript ]
			separatedBy: [ aStream nextPutAll: ', ' ].
		aStream nextPut: $} ].
! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 2/22/2006 14:09'!
printParamsOn: aStream
	aStream nextPut: $(; nextPutAll: self idString.
	self printArgsOn: aStream; printOptionsOn: aStream.
	aStream nextPut: $).! !

!SUPrototype methodsFor: 'printing-parts' stamp: 'lr 2/22/2006 11:58'!
printTypeOn: aStream
	self shouldCreateInstance 
		ifTrue: [ aStream nextPutAll: 'new ' ].
	aStream nextPutAll: self type.! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 16:31'!
returnFalse
	^ self displayString, '; return false;'! !

!SUPrototype methodsFor: 'conveniance' stamp: 'lr 2/22/2006 16:56'!
session
	^ WACurrentSession value.! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 9/24/2005 19:30'!
shouldCreateInstance
	^ true! !

!SUPrototype methodsFor: 'as yet unclassified' stamp: 'avi 6/22/2005 15:53'!
type
	^ self subclassResponsibility! !

SUPrototype subclass: #SUSlider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUSlider methodsFor: 'options' stamp: 'lr 3/1/2006 21:57'!
alignX: aNumber
	"This will move the starting point on the x-axis for the handle in relation to the track. It is often used to move the 'point' of the handle to where 0 should be. It can also be used to set a different starting point on the track."

	self optionAt: 'alignX' put: aNumber.! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/1/2006 21:57'!
alignY: aNumber
	"This will move the starting point on the y-axis for the handle in relation to the track. It is often used to move the 'point' of the handle to where 0 should be. It can also be used to set a different starting point on the track."

	self optionAt: 'alignY' put: aNumber.! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/1/2006 21:53'!
axis: aString
	"Sets the direction that the slider will move in. It should either be horizontal or vertical."

	self optionAt: 'axis' put: aString.! !

!SUSlider methodsFor: 'private' stamp: 'lr 3/1/2006 21:51'!
defaultEffect
	^ 'Slider'! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/1/2006 22:00'!
disabled: aBoolean
	"This will lock the slider so that it will not move and thus is disabled."

	self optionAt: 'disabled' put: aBoolean.! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/1/2006 21:53'!
increment: aNumber
	"Defines the relationship of value to pixels. Setting this to 1 will mean each movement of 1 pixel equates to 1 value."

	self optionAt: 'increment' put: aNumber.! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/1/2006 21:53'!
maximum: aNumber
	"The maximum value that the slider will move to. For horizontal this is to the right while vertical it is down."

	self optionAt: 'maximum' put: aNumber.! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/1/2006 21:54'!
minimum: aNumber
	"The minimum value that the slider can move to. For horizontal this is to the left while vertical it is up. Note: this also sets the beginning of the slider (zeroes it out)."

	self optionAt: 'minimum' put: aNumber.! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/1/2006 21:59'!
sliderValue: aNumber
	"Will set the initial slider value. The handle will be set to this value, assuming it is within the minimum and maxium values."

	self optionAt: 'sliderValue' put: aNumber.! !

!SUSlider methodsFor: 'private' stamp: 'lr 3/1/2006 21:52'!
type
	^ 'Control'! !

!SUSlider methodsFor: 'options' stamp: 'lr 3/1/2006 22:01'!
values: anArray
	"Accepts an array of integers. If set these will be the only legal values for the slider to be at. Thus you can set specific slider values that the user can move the slider to."

	self optionAt: 'values' put: anArray.! !

SUPrototype subclass: #SUSortable
	instanceVariableNames: 'callback list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUSortable methodsFor: 'options' stamp: 'lr 2/22/2006 07:08'!
containment: anArray
	"Enables dragging and dropping between Sortables. Takes an array of elements or element-ids (of the containers)."

	self optionAt: 'containment' put: anArray.! !

!SUSortable methodsFor: 'actions' stamp: 'lr 2/22/2006 09:41'!
create
	^ self effect: 'create'.! !

!SUSortable methodsFor: 'private' stamp: 'lr 2/22/2006 07:32'!
defaultEffect
	^ 'create'! !

!SUSortable methodsFor: 'actions' stamp: 'lr 2/22/2006 09:41'!
destroy
	^ self effect: 'destroy'.! !

!SUSortable methodsFor: 'options' stamp: 'lr 2/22/2006 15:23'!
ghosting: aBoolean
	"If set to true, dragged elements of the Sortable will e cloned and appear as 'ghost', i.e. a representation of their original element, instead of directly dragging the original element. See below for more details."

	self optionAt: 'ghosting' put: aBoolean.! !

!SUSortable methodsFor: 'events' stamp: 'lr 2/22/2006 09:58'!
onChange: aPrototype
	"Called whenever the sort order changes while dragging. When dragging from one Sortable to another, the callback is called once on each Sortable. Gets the affected element as its parameter."

	self optionAt: 'onChange' put: (SUJavascript function: aPrototype).! !

!SUSortable methodsFor: 'options' stamp: 'lr 2/22/2006 07:04'!
only: aString
	"Further restricts the selection of child elements to only encompass elements with the given CSS class (or, if you provide an array of strings, on any of the classes)."

	self optionAt: 'only' put: aString.! !

!SUSortable methodsFor: 'events' stamp: 'lr 2/22/2006 10:16'!
onUpdate: aPrototype
	"Called when the drag ends and the Sortable's order is changed in any way. When dragging from one Sortable to another, the callback is called once on each Sortable. Gets the container as its parameter. Note that the id attributes of the elements contained in the Sortable must be named as described in Sortable.serialize."

	self optionAt: 'onUpdate' put: (SUJavascript function: aPrototype).! !

!SUSortable methodsFor: 'actions' stamp: 'lr 2/22/2006 09:40'!
serialize
	^ self effect: 'serialize'.! !

!SUSortable methodsFor: 'private' stamp: 'lr 2/22/2006 07:02'!
shouldCreateInstance
	^ false! !

!SUSortable methodsFor: 'options' stamp: 'lr 2/22/2006 07:03'!
tag: aString
	"Sets the kind of tag (of the child elements of the container) that will be made sortable. For UL and OL containers, this is 'LI', you have to provide the tag kind for other sorts of child tags."

	self optionAt: 'tag' put: aString.! !

!SUSortable methodsFor: 'conveniance' stamp: 'lr 2/22/2006 16:57'!
transform: aCollection
	| mapping |
	mapping := self session currentRequest fields
		at: id , '[]' ifAbsent: [ 1 to: aCollection size ].
	^ mapping collect: [ :each | aCollection at: each asInteger ].! !

!SUSortable methodsFor: 'private' stamp: 'lr 2/22/2006 07:31'!
type
	^ 'Sortable'! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 3/1/2006 21:26'!
ajax
	^ self ajaxInstanceFor: SUAjax.! !

!WARenderCanvas methodsFor: '*scriptaculous-private' stamp: 'lr 3/1/2006 21:26'!
ajaxInstanceFor: aClass
	| ajax callbackKey |
	ajax := aClass new.
	callbackKey := self callbacks registerActionCallback: [ self performAjaxResponseFor: ajax ].
	ajax url: (self context actionUrl withParameter: callbackKey).
	^ ajax.! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 3/1/2006 21:30'!
autocomplete: aString
	^ (self ajaxInstanceFor: SUAutocompleter)
		setTarget: aString;
		yourself.! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 2/14/2006 16:03'!
draggable
	^ SUDraggable new! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 2/14/2006 16:37'!
droppable
	^ SUDroppable new! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'avi 9/21/2005 22:57'!
effect
	^ SUEffect new! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'avi 9/24/2005 19:32'!
element
	^ SUElement new! !

!WARenderCanvas methodsFor: '*scriptaculous-private' stamp: 'lr 2/21/2006 17:42'!
performAjaxResponseFor: anAjax
	| innerContext docRoot document response canvas  |
	innerContext := context copy.
	docRoot := WARenderedHtmlRoot context: innerContext.
	docRoot resourceBaseUrl: innerContext document root resourceBaseUrl.
	document := SUAjaxDocument root: docRoot.
	response := WAResponse new.
	response headerAt: 'Cache-Control' put: 'No-cache'.
	document stream: response stream.
	context document: document.
	canvas := self species context: context callbacks: callbacks.
	canvas render: anAjax; flush.
	document close.
	WACurrentSession value returnResponse: response.! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 3/1/2006 21:36'!
periodical
	^ self ajaxInstanceFor: SUPeriodicalUpdater.! !

!WARenderCanvas methodsFor: '*scriptaculous' stamp: 'lr 2/22/2006 07:13'!
sortable
	^ SUSortable new! !

WAFrameComponent subclass: #SUAllTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Testing'!

!SUAllTests class methodsFor: 'initialization' stamp: 'lr 2/21/2006 20:51'!
initialize
	(self registerAsApplication: 'scriptaculous')
		libraries add: SUScriptLibrary.! !

!SUAllTests methodsFor: 'initialization' stamp: 'lr 3/1/2006 21:45'!
initialize
	self contents: (WASimpleNavigation new
		add: SUCounterTest new label: 'Counter';
		add: SUAutocompleteTest new label: 'Autocomplete';
		add: SUEffectTest new label: 'Effects';
		add: SUPeriodicalTest new label: 'Periodical';
		add: SUInsertTest new label: 'Insert';
		add: SUFormTest new label: 'Form';
		add: SUSortableTest new label: 'Sortable';
		yourself).! !

!SUAllTests methodsFor: 'rendering' stamp: 'lr 2/22/2006 16:58'!
renderContentOn: html
	html heading: 'script.aculo.us'.
	super renderContentOn: html.! !

WAHtmlStreamDocument subclass: #SUAjaxDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUAjaxDocument methodsFor: 'as yet unclassified' stamp: 'lr 2/21/2006 14:49'!
close! !

!SUAjaxDocument methodsFor: 'as yet unclassified' stamp: 'lr 2/14/2006 22:22'!
initializeWithRoot: anHtmlRoot
	super initializeWithRoot: anHtmlRoot.
	state := #body.! !

!WASession methodsFor: '*scriptaculous' stamp: 'avi 9/24/2005 19:43'!
effect
	^ self addLoadScript: SUEffect new! !

!WARenderingContext methodsFor: '*scriptaculous' stamp: 'lr 2/14/2006 20:55'!
callbacks
	^ callbacks! !

!Dictionary methodsFor: '*scriptaculous' stamp: 'avi 6/30/2005 13:56'!
asJavascript
	^ String streamContents:
			[:s |
			s nextPutAll: '{ '.
			self associations
				do: [:assoc | s
					nextPutAll: assoc key asString;
					nextPutAll: ': ';
					nextPutAll: assoc value asJavascript]
				separatedBy: [s nextPutAll: ', '].
			s nextPutAll: ' }']! !

!String methodsFor: '*scriptaculous' stamp: 'pmm 12/22/2005 21:57'!
asJavascript
	^self class streamContents: [ :stream |
		stream nextPut: $'.
		self do: [ :each |
			each = $' ifTrue: [ stream nextPut: $\ ].
			stream nextPut: each ].
		stream nextPut: $' ]! !

WAScriptLibrary subclass: #SUScriptLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Core'!

!SUScriptLibrary methodsFor: 'scriptaculous' stamp: 'lr 2/14/2006 12:22'!
aPrototype
	^ '/*  Prototype JavaScript framework, version 1.4.0
 *  (c) 2005 Sam Stephenson <sam@conio.net>
 *
 *  THIS FILE IS AUTOMATICALLY GENERATED. When sending patches, please diff
 *  against the source tree, available from the Prototype darcs repository.
 *
 *  Prototype is freely distributable under the terms of an MIT-style license.
 *
 *  For details, see the Prototype web site: http://prototype.conio.net/
 *
/*--------------------------------------------------------------------------*/

var Prototype = {
  Version: ''1.4.0'',
  ScriptFragment: ''(?:<script.*?>)((\n|\r|.)*?)(?:<\/script>)'',

  emptyFunction: function() {},
  K: function(x) {return x}
}

var Class = {
  create: function() {
    return function() {
      this.initialize.apply(this, arguments);
    }
  }
}

var Abstract = new Object();

Object.extend = function(destination, source) {
  for (property in source) {
    destination[property] = source[property];
  }
  return destination;
}

Object.inspect = function(object) {
  try {
    if (object == undefined) return ''undefined'';
    if (object == null) return ''null'';
    return object.inspect ? object.inspect() : object.toString();
  } catch (e) {
    if (e instanceof RangeError) return ''...'';
    throw e;
  }
}

Function.prototype.bind = function() {
  var __method = this, args = $A(arguments), object = args.shift();
  return function() {
    return __method.apply(object, args.concat($A(arguments)));
  }
}

Function.prototype.bindAsEventListener = function(object) {
  var __method = this;
  return function(event) {
    return __method.call(object, event || window.event);
  }
}

Object.extend(Number.prototype, {
  toColorPart: function() {
    var digits = this.toString(16);
    if (this < 16) return ''0'' + digits;
    return digits;
  },

  succ: function() {
    return this + 1;
  },

  times: function(iterator) {
    $R(0, this, true).each(iterator);
    return this;
  }
});

var Try = {
  these: function() {
    var returnValue;

    for (var i = 0; i < arguments.length; i++) {
      var lambda = arguments[i];
      try {
        returnValue = lambda();
        break;
      } catch (e) {}
    }

    return returnValue;
  }
}

/*--------------------------------------------------------------------------*/

var PeriodicalExecuter = Class.create();
PeriodicalExecuter.prototype = {
  initialize: function(callback, frequency) {
    this.callback = callback;
    this.frequency = frequency;
    this.currentlyExecuting = false;

    this.registerCallback();
  },

  registerCallback: function() {
    setInterval(this.onTimerEvent.bind(this), this.frequency * 1000);
  },

  onTimerEvent: function() {
    if (!!this.currentlyExecuting) {
      try {
        this.currentlyExecuting = true;
        this.callback();
      } finally {
        this.currentlyExecuting = false;
      }
    }
  }
}

/*--------------------------------------------------------------------------*/

function $() {
  var elements = new Array();

  for (var i = 0; i < arguments.length; i++) {
    var element = arguments[i];
    if (typeof element == ''string'')
      element = document.getElementById(element);

    if (arguments.length == 1)
      return element;

    elements.push(element);
  }

  return elements;
}
Object.extend(String.prototype, {
  stripTags: function() {
    return this.replace(/<\/?[^>]+>/gi, '''');
  },

  stripScripts: function() {
    return this.replace(new RegExp(Prototype.ScriptFragment, ''img''), '''');
  },

  extractScripts: function() {
    var matchAll = new RegExp(Prototype.ScriptFragment, ''img'');
    var matchOne = new RegExp(Prototype.ScriptFragment, ''im'');
    return (this.match(matchAll) || []).map(function(scriptTag) {
      return (scriptTag.match(matchOne) || ['''', ''''])[1];
    });
  },

  evalScripts: function() {
    return this.extractScripts().map(eval);
  },

  escapeHTML: function() {
    var div = document.createElement(''div'');
    var text = document.createTextNode(this);
    div.appendChild(text);
    return div.innerHTML;
  },

  unescapeHTML: function() {
    var div = document.createElement(''div'');
    div.innerHTML = this.stripTags();
    return div.childNodes[0] ? div.childNodes[0].nodeValue : '''';
  },

  toQueryParams: function() {
    var pairs = this.match(/^\??(.*)$/)[1].split(''&'');
    return pairs.inject({}, function(params, pairString) {
      var pair = pairString.split(''='');
      params[pair[0]] = pair[1];
      return params;
    });
  },

  toArray: function() {
    return this.split('''');
  },

  camelize: function() {
    var oStringList = this.split(''-'');
    if (oStringList.length == 1) return oStringList[0];

    var camelizedString = this.indexOf(''-'') == 0
      ? oStringList[0].charAt(0).toUpperCase() + oStringList[0].substring(1)
      : oStringList[0];

    for (var i = 1, len = oStringList.length; i < len; i++) {
      var s = oStringList[i];
      camelizedString += s.charAt(0).toUpperCase() + s.substring(1);
    }

    return camelizedString;
  },

  inspect: function() {
    return "''" + this.replace(''\\'', ''\\\\'').replace("''", ''\\\'''') + "''";
  }
});

String.prototype.parseQuery = String.prototype.toQueryParams;

var $break    = new Object();
var $continue = new Object();

var Enumerable = {
  each: function(iterator) {
    var index = 0;
    try {
      this._each(function(value) {
        try {
          iterator(value, index++);
        } catch (e) {
          if (e !!= $continue) throw e;
        }
      });
    } catch (e) {
      if (e !!= $break) throw e;
    }
  },

  all: function(iterator) {
    var result = true;
    this.each(function(value, index) {
      result = result && !!!!(iterator || Prototype.K)(value, index);
      if (!!result) throw $break;
    });
    return result;
  },

  any: function(iterator) {
    var result = true;
    this.each(function(value, index) {
      if (result = !!!!(iterator || Prototype.K)(value, index))
        throw $break;
    });
    return result;
  },

  collect: function(iterator) {
    var results = [];
    this.each(function(value, index) {
      results.push(iterator(value, index));
    });
    return results;
  },

  detect: function (iterator) {
    var result;
    this.each(function(value, index) {
      if (iterator(value, index)) {
        result = value;
        throw $break;
      }
    });
    return result;
  },

  findAll: function(iterator) {
    var results = [];
    this.each(function(value, index) {
      if (iterator(value, index))
        results.push(value);
    });
    return results;
  },

  grep: function(pattern, iterator) {
    var results = [];
    this.each(function(value, index) {
      var stringValue = value.toString();
      if (stringValue.match(pattern))
        results.push((iterator || Prototype.K)(value, index));
    })
    return results;
  },

  include: function(object) {
    var found = false;
    this.each(function(value) {
      if (value == object) {
        found = true;
        throw $break;
      }
    });
    return found;
  },

  inject: function(memo, iterator) {
    this.each(function(value, index) {
      memo = iterator(memo, value, index);
    });
    return memo;
  },

  invoke: function(method) {
    var args = $A(arguments).slice(1);
    return this.collect(function(value) {
      return value[method].apply(value, args);
    });
  },

  max: function(iterator) {
    var result;
    this.each(function(value, index) {
      value = (iterator || Prototype.K)(value, index);
      if (value >= (result || value))
        result = value;
    });
    return result;
  },

  min: function(iterator) {
    var result;
    this.each(function(value, index) {
      value = (iterator || Prototype.K)(value, index);
      if (value <= (result || value))
        result = value;
    });
    return result;
  },

  partition: function(iterator) {
    var trues = [], falses = [];
    this.each(function(value, index) {
      ((iterator || Prototype.K)(value, index) ?
        trues : falses).push(value);
    });
    return [trues, falses];
  },

  pluck: function(property) {
    var results = [];
    this.each(function(value, index) {
      results.push(value[property]);
    });
    return results;
  },

  reject: function(iterator) {
    var results = [];
    this.each(function(value, index) {
      if (!!iterator(value, index))
        results.push(value);
    });
    return results;
  },

  sortBy: function(iterator) {
    return this.collect(function(value, index) {
      return {value: value, criteria: iterator(value, index)};
    }).sort(function(left, right) {
      var a = left.criteria, b = right.criteria;
      return a < b ? -1 : a > b ? 1 : 0;
    }).pluck(''value'');
  },

  toArray: function() {
    return this.collect(Prototype.K);
  },

  zip: function() {
    var iterator = Prototype.K, args = $A(arguments);
    if (typeof args.last() == ''function'')
      iterator = args.pop();

    var collections = [this].concat(args).map($A);
    return this.map(function(value, index) {
      iterator(value = collections.pluck(index));
      return value;
    });
  },

  inspect: function() {
    return ''#<Enumerable:'' + this.toArray().inspect() + ''>'';
  }
}

Object.extend(Enumerable, {
  map:     Enumerable.collect,
  find:    Enumerable.detect,
  select:  Enumerable.findAll,
  member:  Enumerable.include,
  entries: Enumerable.toArray
});
var $A = Array.from = function(iterable) {
  if (!!iterable) return [];
  if (iterable.toArray) {
    return iterable.toArray();
  } else {
    var results = [];
    for (var i = 0; i < iterable.length; i++)
      results.push(iterable[i]);
    return results;
  }
}

Object.extend(Array.prototype, Enumerable);

Array.prototype._reverse = Array.prototype.reverse;

Object.extend(Array.prototype, {
  _each: function(iterator) {
    for (var i = 0; i < this.length; i++)
      iterator(this[i]);
  },

  clear: function() {
    this.length = 0;
    return this;
  },

  first: function() {
    return this[0];
  },

  last: function() {
    return this[this.length - 1];
  },

  compact: function() {
    return this.select(function(value) {
      return value !!= undefined || value !!= null;
    });
  },

  flatten: function() {
    return this.inject([], function(array, value) {
      return array.concat(value.constructor == Array ?
        value.flatten() : [value]);
    });
  },

  without: function() {
    var values = $A(arguments);
    return this.select(function(value) {
      return !!values.include(value);
    });
  },

  indexOf: function(object) {
    for (var i = 0; i < this.length; i++)
      if (this[i] == object) return i;
    return -1;
  },

  reverse: function(inline) {
    return (inline !!== false ? this : this.toArray())._reverse();
  },

  shift: function() {
    var result = this[0];
    for (var i = 0; i < this.length - 1; i++)
      this[i] = this[i + 1];
    this.length--;
    return result;
  },

  inspect: function() {
    return ''['' + this.map(Object.inspect).join('', '') + '']'';
  }
});
var Hash = {
  _each: function(iterator) {
    for (key in this) {
      var value = this[key];
      if (typeof value == ''function'') continue;

      var pair = [key, value];
      pair.key = key;
      pair.value = value;
      iterator(pair);
    }
  },

  keys: function() {
    return this.pluck(''key'');
  },

  values: function() {
    return this.pluck(''value'');
  },

  merge: function(hash) {
    return $H(hash).inject($H(this), function(mergedHash, pair) {
      mergedHash[pair.key] = pair.value;
      return mergedHash;
    });
  },

  toQueryString: function() {
    return this.map(function(pair) {
      return pair.map(encodeURIComponent).join(''='');
    }).join(''&'');
  },

  inspect: function() {
    return ''#<Hash:{'' + this.map(function(pair) {
      return pair.map(Object.inspect).join('': '');
    }).join('', '') + ''}>'';
  }
}

function $H(object) {
  var hash = Object.extend({}, object || {});
  Object.extend(hash, Enumerable);
  Object.extend(hash, Hash);
  return hash;
}
ObjectRange = Class.create();
Object.extend(ObjectRange.prototype, Enumerable);
Object.extend(ObjectRange.prototype, {
  initialize: function(start, end, exclusive) {
    this.start = start;
    this.end = end;
    this.exclusive = exclusive;
  },

  _each: function(iterator) {
    var value = this.start;
    do {
      iterator(value);
      value = value.succ();
    } while (this.include(value));
  },

  include: function(value) {
    if (value < this.start)
      return false;
    if (this.exclusive)
      return value < this.end;
    return value <= this.end;
  }
});

var $R = function(start, end, exclusive) {
  return new ObjectRange(start, end, exclusive);
}

var Ajax = {
  getTransport: function() {
    return Try.these(
      function() {return new ActiveXObject(''Msxml2.XMLHTTP'')},
      function() {return new ActiveXObject(''Microsoft.XMLHTTP'')},
      function() {return new XMLHttpRequest()}
    ) || false;
  },

  activeRequestCount: 0
}

Ajax.Responders = {
  responders: [],

  _each: function(iterator) {
    this.responders._each(iterator);
  },

  register: function(responderToAdd) {
    if (!!this.include(responderToAdd))
      this.responders.push(responderToAdd);
  },

  unregister: function(responderToRemove) {
    this.responders = this.responders.without(responderToRemove);
  },

  dispatch: function(callback, request, transport, json) {
    this.each(function(responder) {
      if (responder[callback] && typeof responder[callback] == ''function'') {
        try {
          responder[callback].apply(responder, [request, transport, json]);
        } catch (e) {}
      }
    });
  }
};

Object.extend(Ajax.Responders, Enumerable);

Ajax.Responders.register({
  onCreate: function() {
    Ajax.activeRequestCount++;
  },

  onComplete: function() {
    Ajax.activeRequestCount--;
  }
});

Ajax.Base = function() {};
Ajax.Base.prototype = {
  setOptions: function(options) {
    this.options = {
      method:       ''post'',
      asynchronous: true,
      parameters:   ''''
    }
    Object.extend(this.options, options || {});
  },

  responseIsSuccess: function() {
    return this.transport.status == undefined
        || this.transport.status == 0
        || (this.transport.status >= 200 && this.transport.status < 300);
  },

  responseIsFailure: function() {
    return !!this.responseIsSuccess();
  }
}

Ajax.Request = Class.create();
Ajax.Request.Events =
  [''Uninitialized'', ''Loading'', ''Loaded'', ''Interactive'', ''Complete''];

Ajax.Request.prototype = Object.extend(new Ajax.Base(), {
  initialize: function(url, options) {
    this.transport = Ajax.getTransport();
    this.setOptions(options);
    this.request(url);
  },

  request: function(url) {
    var parameters = this.options.parameters || '''';
    if (parameters.length > 0) parameters += ''&_='';

    try {
      this.url = url;
      if (this.options.method == ''get'' && parameters.length > 0)
        this.url += (this.url.match(/\?/) ? ''&'' : ''?'') + parameters;

      Ajax.Responders.dispatch(''onCreate'', this, this.transport);

      this.transport.open(this.options.method, this.url,
        this.options.asynchronous);

      if (this.options.asynchronous) {
        this.transport.onreadystatechange = this.onStateChange.bind(this);
        setTimeout((function() {this.respondToReadyState(1)}).bind(this), 10);
      }

      this.setRequestHeaders();

      var body = this.options.postBody ? this.options.postBody : parameters;
      this.transport.send(this.options.method == ''post'' ? body : null);

    } catch (e) {
      this.dispatchException(e);
    }
  },

  setRequestHeaders: function() {
    var requestHeaders =
      [''X-Requested-With'', ''XMLHttpRequest'',
       ''X-Prototype-Version'', Prototype.Version];

    if (this.options.method == ''post'') {
      requestHeaders.push(''Content-type'',
        ''application/x-www-form-urlencoded'');

      /* Force "Connection: close" for Mozilla browsers to work around
       * a bug where XMLHttpReqeuest sends an incorrect Content-length
       * header. See Mozilla Bugzilla #246651.
       */
      if (this.transport.overrideMimeType)
        requestHeaders.push(''Connection'', ''close'');
    }

    if (this.options.requestHeaders)
      requestHeaders.push.apply(requestHeaders, this.options.requestHeaders);

    for (var i = 0; i < requestHeaders.length; i += 2)
      this.transport.setRequestHeader(requestHeaders[i], requestHeaders[i+1]);
  },

  onStateChange: function() {
    var readyState = this.transport.readyState;
    if (readyState !!= 1)
      this.respondToReadyState(this.transport.readyState);
  },

  header: function(name) {
    try {
      return this.transport.getResponseHeader(name);
    } catch (e) {}
  },

  evalJSON: function() {
    try {
      return eval(this.header(''X-JSON''));
    } catch (e) {}
  },

  evalResponse: function() {
    try {
      return eval(this.transport.responseText);
    } catch (e) {
      this.dispatchException(e);
    }
  },

  respondToReadyState: function(readyState) {
    var event = Ajax.Request.Events[readyState];
    var transport = this.transport, json = this.evalJSON();

    if (event == ''Complete'') {
      try {
        (this.options[''on'' + this.transport.status]
         || this.options[''on'' + (this.responseIsSuccess() ? ''Success'' : ''Failure'')]
         || Prototype.emptyFunction)(transport, json);
      } catch (e) {
        this.dispatchException(e);
      }

      if ((this.header(''Content-type'') || '''').match(/^text\/javascript/i))
        this.evalResponse();
    }

    try {
      (this.options[''on'' + event] || Prototype.emptyFunction)(transport, json);
      Ajax.Responders.dispatch(''on'' + event, this, transport, json);
    } catch (e) {
      this.dispatchException(e);
    }

    /* Avoid memory leak in MSIE: clean up the oncomplete event handler */
    if (event == ''Complete'')
      this.transport.onreadystatechange = Prototype.emptyFunction;
  },

  dispatchException: function(exception) {
    (this.options.onException || Prototype.emptyFunction)(this, exception);
    Ajax.Responders.dispatch(''onException'', this, exception);
  }
});

Ajax.Updater = Class.create();

Object.extend(Object.extend(Ajax.Updater.prototype, Ajax.Request.prototype), {
  initialize: function(container, url, options) {
    this.containers = {
      success: container.success ? $(container.success) : $(container),
      failure: container.failure ? $(container.failure) :
        (container.success ? null : $(container))
    }

    this.transport = Ajax.getTransport();
    this.setOptions(options);

    var onComplete = this.options.onComplete || Prototype.emptyFunction;
    this.options.onComplete = (function(transport, object) {
      this.updateContent();
      onComplete(transport, object);
    }).bind(this);

    this.request(url);
  },

  updateContent: function() {
    var receiver = this.responseIsSuccess() ?
      this.containers.success : this.containers.failure;
    var response = this.transport.responseText;

    if (!!this.options.evalScripts)
      response = response.stripScripts();

    if (receiver) {
      if (this.options.insertion) {
        new this.options.insertion(receiver, response);
      } else {
        Element.update(receiver, response);
      }
    }

    if (this.responseIsSuccess()) {
      if (this.onComplete)
        setTimeout(this.onComplete.bind(this), 10);
    }
  }
});

Ajax.PeriodicalUpdater = Class.create();
Ajax.PeriodicalUpdater.prototype = Object.extend(new Ajax.Base(), {
  initialize: function(container, url, options) {
    this.setOptions(options);
    this.onComplete = this.options.onComplete;

    this.frequency = (this.options.frequency || 2);
    this.decay = (this.options.decay || 1);

    this.updater = {};
    this.container = container;
    this.url = url;

    this.start();
  },

  start: function() {
    this.options.onComplete = this.updateComplete.bind(this);
    this.onTimerEvent();
  },

  stop: function() {
    this.updater.onComplete = undefined;
    clearTimeout(this.timer);
    (this.onComplete || Prototype.emptyFunction).apply(this, arguments);
  },

  updateComplete: function(request) {
    if (this.options.decay) {
      this.decay = (request.responseText == this.lastText ?
        this.decay * this.options.decay : 1);

      this.lastText = request.responseText;
    }
    this.timer = setTimeout(this.onTimerEvent.bind(this),
      this.decay * this.frequency * 1000);
  },

  onTimerEvent: function() {
    this.updater = new Ajax.Updater(this.container, this.url, this.options);
  }
});
document.getElementsByClassName = function(className, parentElement) {
  var children = ($(parentElement) || document.body).getElementsByTagName(''*'');
  return $A(children).inject([], function(elements, child) {
    if (child.className.match(new RegExp("(^|\\s)" + className + "(\\s|$)")))
      elements.push(child);
    return elements;
  });
}

/*--------------------------------------------------------------------------*/

if (!!window.Element) {
  var Element = new Object();
}

Object.extend(Element, {
  visible: function(element) {
    return $(element).style.display !!= ''none'';
  },

  toggle: function() {
    for (var i = 0; i < arguments.length; i++) {
      var element = $(arguments[i]);
      Element[Element.visible(element) ? ''hide'' : ''show''](element);
    }
  },

  hide: function() {
    for (var i = 0; i < arguments.length; i++) {
      var element = $(arguments[i]);
      element.style.display = ''none'';
    }
  },

  show: function() {
    for (var i = 0; i < arguments.length; i++) {
      var element = $(arguments[i]);
      element.style.display = '''';
    }
  },

  remove: function(element) {
    element = $(element);
    element.parentNode.removeChild(element);
  },

  update: function(element, html) {
    $(element).innerHTML = html.stripScripts();
    setTimeout(function() {html.evalScripts()}, 10);
  },

  getHeight: function(element) {
    element = $(element);
    return element.offsetHeight;
  },

  classNames: function(element) {
    return new Element.ClassNames(element);
  },

  hasClassName: function(element, className) {
    if (!!(element = $(element))) return;
    return Element.classNames(element).include(className);
  },

  addClassName: function(element, className) {
    if (!!(element = $(element))) return;
    return Element.classNames(element).add(className);
  },

  removeClassName: function(element, className) {
    if (!!(element = $(element))) return;
    return Element.classNames(element).remove(className);
  },

  // removes whitespace-only text node children
  cleanWhitespace: function(element) {
    element = $(element);
    for (var i = 0; i < element.childNodes.length; i++) {
      var node = element.childNodes[i];
      if (node.nodeType == 3 && !!/\S/.test(node.nodeValue))
        Element.remove(node);
    }
  },

  empty: function(element) {
    return $(element).innerHTML.match(/^\s*$/);
  },

  scrollTo: function(element) {
    element = $(element);
    var x = element.x ? element.x : element.offsetLeft,
        y = element.y ? element.y : element.offsetTop;
    window.scrollTo(x, y);
  },

  getStyle: function(element, style) {
    element = $(element);
    var value = element.style[style.camelize()];
    if (!!value) {
      if (document.defaultView && document.defaultView.getComputedStyle) {
        var css = document.defaultView.getComputedStyle(element, null);
        value = css ? css.getPropertyValue(style) : null;
      } else if (element.currentStyle) {
        value = element.currentStyle[style.camelize()];
      }
    }

    if (window.opera && [''left'', ''top'', ''right'', ''bottom''].include(style))
      if (Element.getStyle(element, ''position'') == ''static'') value = ''auto'';

    return value == ''auto'' ? null : value;
  },

  setStyle: function(element, style) {
    element = $(element);
    for (name in style)
      element.style[name.camelize()] = style[name];
  },

  getDimensions: function(element) {
    element = $(element);
    if (Element.getStyle(element, ''display'') !!= ''none'')
      return {width: element.offsetWidth, height: element.offsetHeight};

    // All *Width and *Height properties give 0 on elements with display none,
    // so enable the element temporarily
    var els = element.style;
    var originalVisibility = els.visibility;
    var originalPosition = els.position;
    els.visibility = ''hidden'';
    els.position = ''absolute'';
    els.display = '''';
    var originalWidth = element.clientWidth;
    var originalHeight = element.clientHeight;
    els.display = ''none'';
    els.position = originalPosition;
    els.visibility = originalVisibility;
    return {width: originalWidth, height: originalHeight};
  },

  makePositioned: function(element) {
    element = $(element);
    var pos = Element.getStyle(element, ''position'');
    if (pos == ''static'' || !!pos) {
      element._madePositioned = true;
      element.style.position = ''relative'';
      // Opera returns the offset relative to the positioning context, when an
      // element is position relative but top and left have not been defined
      if (window.opera) {
        element.style.top = 0;
        element.style.left = 0;
      }
    }
  },

  undoPositioned: function(element) {
    element = $(element);
    if (element._madePositioned) {
      element._madePositioned = undefined;
      element.style.position =
        element.style.top =
        element.style.left =
        element.style.bottom =
        element.style.right = '''';
    }
  },

  makeClipping: function(element) {
    element = $(element);
    if (element._overflow) return;
    element._overflow = element.style.overflow;
    if ((Element.getStyle(element, ''overflow'') || ''visible'') !!= ''hidden'')
      element.style.overflow = ''hidden'';
  },

  undoClipping: function(element) {
    element = $(element);
    if (element._overflow) return;
    element.style.overflow = element._overflow;
    element._overflow = undefined;
  }
});

var Toggle = new Object();
Toggle.display = Element.toggle;

/*--------------------------------------------------------------------------*/

Abstract.Insertion = function(adjacency) {
  this.adjacency = adjacency;
}

Abstract.Insertion.prototype = {
  initialize: function(element, content) {
    this.element = $(element);
    this.content = content.stripScripts();

    if (this.adjacency && this.element.insertAdjacentHTML) {
      try {
        this.element.insertAdjacentHTML(this.adjacency, this.content);
      } catch (e) {
        if (this.element.tagName.toLowerCase() == ''tbody'') {
          this.insertContent(this.contentFromAnonymousTable());
        } else {
          throw e;
        }
      }
    } else {
      this.range = this.element.ownerDocument.createRange();
      if (this.initializeRange) this.initializeRange();
      this.insertContent([this.range.createContextualFragment(this.content)]);
    }

    setTimeout(function() {content.evalScripts()}, 10);
  },

  contentFromAnonymousTable: function() {
    var div = document.createElement(''div'');
    div.innerHTML = ''<table><tbody>'' + this.content + ''</tbody></table>'';
    return $A(div.childNodes[0].childNodes[0].childNodes);
  }
}

var Insertion = new Object();

Insertion.Before = Class.create();
Insertion.Before.prototype = Object.extend(new Abstract.Insertion(''beforeBegin''), {
  initializeRange: function() {
    this.range.setStartBefore(this.element);
  },

  insertContent: function(fragments) {
    fragments.each((function(fragment) {
      this.element.parentNode.insertBefore(fragment, this.element);
    }).bind(this));
  }
});

Insertion.Top = Class.create();
Insertion.Top.prototype = Object.extend(new Abstract.Insertion(''afterBegin''), {
  initializeRange: function() {
    this.range.selectNodeContents(this.element);
    this.range.collapse(true);
  },

  insertContent: function(fragments) {
    fragments.reverse(false).each((function(fragment) {
      this.element.insertBefore(fragment, this.element.firstChild);
    }).bind(this));
  }
});

Insertion.Bottom = Class.create();
Insertion.Bottom.prototype = Object.extend(new Abstract.Insertion(''beforeEnd''), {
  initializeRange: function() {
    this.range.selectNodeContents(this.element);
    this.range.collapse(this.element);
  },

  insertContent: function(fragments) {
    fragments.each((function(fragment) {
      this.element.appendChild(fragment);
    }).bind(this));
  }
});

Insertion.After = Class.create();
Insertion.After.prototype = Object.extend(new Abstract.Insertion(''afterEnd''), {
  initializeRange: function() {
    this.range.setStartAfter(this.element);
  },

  insertContent: function(fragments) {
    fragments.each((function(fragment) {
      this.element.parentNode.insertBefore(fragment,
        this.element.nextSibling);
    }).bind(this));
  }
});

/*--------------------------------------------------------------------------*/

Element.ClassNames = Class.create();
Element.ClassNames.prototype = {
  initialize: function(element) {
    this.element = $(element);
  },

  _each: function(iterator) {
    this.element.className.split(/\s+/).select(function(name) {
      return name.length > 0;
    })._each(iterator);
  },

  set: function(className) {
    this.element.className = className;
  },

  add: function(classNameToAdd) {
    if (this.include(classNameToAdd)) return;
    this.set(this.toArray().concat(classNameToAdd).join('' ''));
  },

  remove: function(classNameToRemove) {
    if (!!this.include(classNameToRemove)) return;
    this.set(this.select(function(className) {
      return className !!= classNameToRemove;
    }).join('' ''));
  },

  toString: function() {
    return this.toArray().join('' '');
  }
}

Object.extend(Element.ClassNames.prototype, Enumerable);
var Field = {
  clear: function() {
    for (var i = 0; i < arguments.length; i++)
      $(arguments[i]).value = '''';
  },

  focus: function(element) {
    $(element).focus();
  },

  present: function() {
    for (var i = 0; i < arguments.length; i++)
      if ($(arguments[i]).value == '''') return false;
    return true;
  },

  select: function(element) {
    $(element).select();
  },

  activate: function(element) {
    element = $(element);
    element.focus();
    if (element.select)
      element.select();
  }
}

/*--------------------------------------------------------------------------*/

var Form = {
  serialize: function(form) {
    var elements = Form.getElements($(form));
    var queryComponents = new Array();

    for (var i = 0; i < elements.length; i++) {
      var queryComponent = Form.Element.serialize(elements[i]);
      if (queryComponent)
        queryComponents.push(queryComponent);
    }

    return queryComponents.join(''&'');
  },

  getElements: function(form) {
    form = $(form);
    var elements = new Array();

    for (tagName in Form.Element.Serializers) {
      var tagElements = form.getElementsByTagName(tagName);
      for (var j = 0; j < tagElements.length; j++)
        elements.push(tagElements[j]);
    }
    return elements;
  },

  getInputs: function(form, typeName, name) {
    form = $(form);
    var inputs = form.getElementsByTagName(''input'');

    if (!!typeName && !!name)
      return inputs;

    var matchingInputs = new Array();
    for (var i = 0; i < inputs.length; i++) {
      var input = inputs[i];
      if ((typeName && input.type !!= typeName) ||
          (name && input.name !!= name))
        continue;
      matchingInputs.push(input);
    }

    return matchingInputs;
  },

  disable: function(form) {
    var elements = Form.getElements(form);
    for (var i = 0; i < elements.length; i++) {
      var element = elements[i];
      element.blur();
      element.disabled = ''true'';
    }
  },

  enable: function(form) {
    var elements = Form.getElements(form);
    for (var i = 0; i < elements.length; i++) {
      var element = elements[i];
      element.disabled = '''';
    }
  },

  findFirstElement: function(form) {
    return Form.getElements(form).find(function(element) {
      return element.type !!= ''hidden'' && !!element.disabled &&
        [''input'', ''select'', ''textarea''].include(element.tagName.toLowerCase());
    });
  },

  focusFirstElement: function(form) {
    Field.activate(Form.findFirstElement(form));
  },

  reset: function(form) {
    $(form).reset();
  }
}

Form.Element = {
  serialize: function(element) {
    element = $(element);
    var method = element.tagName.toLowerCase();
    var parameter = Form.Element.Serializers[method](element);

    if (parameter) {
      var key = encodeURIComponent(parameter[0]);
      if (key.length == 0) return;

      if (parameter[1].constructor !!= Array)
        parameter[1] = [parameter[1]];

      return parameter[1].map(function(value) {
        return key + ''='' + encodeURIComponent(value);
      }).join(''&'');
    }
  },

  getValue: function(element) {
    element = $(element);
    var method = element.tagName.toLowerCase();
    var parameter = Form.Element.Serializers[method](element);

    if (parameter)
      return parameter[1];
  }
}

Form.Element.Serializers = {
  input: function(element) {
    switch (element.type.toLowerCase()) {
      case ''submit'':
      case ''hidden'':
      case ''password'':
      case ''text'':
        return Form.Element.Serializers.textarea(element);
      case ''checkbox'':
      case ''radio'':
        return Form.Element.Serializers.inputSelector(element);
    }
    return false;
  },

  inputSelector: function(element) {
    if (element.checked)
      return [element.name, element.value];
  },

  textarea: function(element) {
    return [element.name, element.value];
  },

  select: function(element) {
    return Form.Element.Serializers[element.type == ''select-one'' ?
      ''selectOne'' : ''selectMany''](element);
  },

  selectOne: function(element) {
    var value = '''', opt, index = element.selectedIndex;
    if (index >= 0) {
      opt = element.options[index];
      value = opt.value;
      if (!!value && !!(''value'' in opt))
        value = opt.text;
    }
    return [element.name, value];
  },

  selectMany: function(element) {
    var value = new Array();
    for (var i = 0; i < element.length; i++) {
      var opt = element.options[i];
      if (opt.selected) {
        var optValue = opt.value;
        if (!!optValue && !!(''value'' in opt))
          optValue = opt.text;
        value.push(optValue);
      }
    }
    return [element.name, value];
  }
}

/*--------------------------------------------------------------------------*/

var $F = Form.Element.getValue;

/*--------------------------------------------------------------------------*/

Abstract.TimedObserver = function() {}
Abstract.TimedObserver.prototype = {
  initialize: function(element, frequency, callback) {
    this.frequency = frequency;
    this.element   = $(element);
    this.callback  = callback;

    this.lastValue = this.getValue();
    this.registerCallback();
  },

  registerCallback: function() {
    setInterval(this.onTimerEvent.bind(this), this.frequency * 1000);
  },

  onTimerEvent: function() {
    var value = this.getValue();
    if (this.lastValue !!= value) {
      this.callback(this.element, value);
      this.lastValue = value;
    }
  }
}

Form.Element.Observer = Class.create();
Form.Element.Observer.prototype = Object.extend(new Abstract.TimedObserver(), {
  getValue: function() {
    return Form.Element.getValue(this.element);
  }
});

Form.Observer = Class.create();
Form.Observer.prototype = Object.extend(new Abstract.TimedObserver(), {
  getValue: function() {
    return Form.serialize(this.element);
  }
});

/*--------------------------------------------------------------------------*/

Abstract.EventObserver = function() {}
Abstract.EventObserver.prototype = {
  initialize: function(element, callback) {
    this.element  = $(element);
    this.callback = callback;

    this.lastValue = this.getValue();
    if (this.element.tagName.toLowerCase() == ''form'')
      this.registerFormCallbacks();
    else
      this.registerCallback(this.element);
  },

  onElementEvent: function() {
    var value = this.getValue();
    if (this.lastValue !!= value) {
      this.callback(this.element, value);
      this.lastValue = value;
    }
  },

  registerFormCallbacks: function() {
    var elements = Form.getElements(this.element);
    for (var i = 0; i < elements.length; i++)
      this.registerCallback(elements[i]);
  },

  registerCallback: function(element) {
    if (element.type) {
      switch (element.type.toLowerCase()) {
        case ''checkbox'':
        case ''radio'':
          Event.observe(element, ''click'', this.onElementEvent.bind(this));
          break;
        case ''password'':
        case ''text'':
        case ''textarea'':
        case ''select-one'':
        case ''select-multiple'':
          Event.observe(element, ''change'', this.onElementEvent.bind(this));
          break;
      }
    }
  }
}

Form.Element.EventObserver = Class.create();
Form.Element.EventObserver.prototype = Object.extend(new Abstract.EventObserver(), {
  getValue: function() {
    return Form.Element.getValue(this.element);
  }
});

Form.EventObserver = Class.create();
Form.EventObserver.prototype = Object.extend(new Abstract.EventObserver(), {
  getValue: function() {
    return Form.serialize(this.element);
  }
});
if (!!window.Event) {
  var Event = new Object();
}

Object.extend(Event, {
  KEY_BACKSPACE: 8,
  KEY_TAB:       9,
  KEY_RETURN:   13,
  KEY_ESC:      27,
  KEY_LEFT:     37,
  KEY_UP:       38,
  KEY_RIGHT:    39,
  KEY_DOWN:     40,
  KEY_DELETE:   46,

  element: function(event) {
    return event.target || event.srcElement;
  },

  isLeftClick: function(event) {
    return (((event.which) && (event.which == 1)) ||
            ((event.button) && (event.button == 1)));
  },

  pointerX: function(event) {
    return event.pageX || (event.clientX +
      (document.documentElement.scrollLeft || document.body.scrollLeft));
  },

  pointerY: function(event) {
    return event.pageY || (event.clientY +
      (document.documentElement.scrollTop || document.body.scrollTop));
  },

  stop: function(event) {
    if (event.preventDefault) {
      event.preventDefault();
      event.stopPropagation();
    } else {
      event.returnValue = false;
      event.cancelBubble = true;
    }
  },

  // find the first node with the given tagName, starting from the
  // node the event was triggered on; traverses the DOM upwards
  findElement: function(event, tagName) {
    var element = Event.element(event);
    while (element.parentNode && (!!element.tagName ||
        (element.tagName.toUpperCase() !!= tagName.toUpperCase())))
      element = element.parentNode;
    return element;
  },

  observers: false,

  _observeAndCache: function(element, name, observer, useCapture) {
    if (!!this.observers) this.observers = [];
    if (element.addEventListener) {
      this.observers.push([element, name, observer, useCapture]);
      element.addEventListener(name, observer, useCapture);
    } else if (element.attachEvent) {
      this.observers.push([element, name, observer, useCapture]);
      element.attachEvent(''on'' + name, observer);
    }
  },

  unloadCache: function() {
    if (!!Event.observers) return;
    for (var i = 0; i < Event.observers.length; i++) {
      Event.stopObserving.apply(this, Event.observers[i]);
      Event.observers[i][0] = null;
    }
    Event.observers = false;
  },

  observe: function(element, name, observer, useCapture) {
    var element = $(element);
    useCapture = useCapture || false;

    if (name == ''keypress'' &&
        (navigator.appVersion.match(/Konqueror|Safari|KHTML/)
        || element.attachEvent))
      name = ''keydown'';

    this._observeAndCache(element, name, observer, useCapture);
  },

  stopObserving: function(element, name, observer, useCapture) {
    var element = $(element);
    useCapture = useCapture || false;

    if (name == ''keypress'' &&
        (navigator.appVersion.match(/Konqueror|Safari|KHTML/)
        || element.detachEvent))
      name = ''keydown'';

    if (element.removeEventListener) {
      element.removeEventListener(name, observer, useCapture);
    } else if (element.detachEvent) {
      element.detachEvent(''on'' + name, observer);
    }
  }
});

/* prevent memory leaks in IE */
Event.observe(window, ''unload'', Event.unloadCache, false);
var Position = {
  // set to true if needed, warning: firefox performance problems
  // NOT neeeded for page scrolling, only if draggable contained in
  // scrollable elements
  includeScrollOffsets: false,

  // must be called before calling withinIncludingScrolloffset, every time the
  // page is scrolled
  prepare: function() {
    this.deltaX =  window.pageXOffset
                || document.documentElement.scrollLeft
                || document.body.scrollLeft
                || 0;
    this.deltaY =  window.pageYOffset
                || document.documentElement.scrollTop
                || document.body.scrollTop
                || 0;
  },

  realOffset: function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.scrollTop  || 0;
      valueL += element.scrollLeft || 0;
      element = element.parentNode;
    } while (element);
    return [valueL, valueT];
  },

  cumulativeOffset: function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;
      element = element.offsetParent;
    } while (element);
    return [valueL, valueT];
  },

  positionedOffset: function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;
      element = element.offsetParent;
      if (element) {
        p = Element.getStyle(element, ''position'');
        if (p == ''relative'' || p == ''absolute'') break;
      }
    } while (element);
    return [valueL, valueT];
  },

  offsetParent: function(element) {
    if (element.offsetParent) return element.offsetParent;
    if (element == document.body) return element;

    while ((element = element.parentNode) && element !!= document.body)
      if (Element.getStyle(element, ''position'') !!= ''static'')
        return element;

    return document.body;
  },

  // caches x/y coordinate pair to use with overlap
  within: function(element, x, y) {
    if (this.includeScrollOffsets)
      return this.withinIncludingScrolloffsets(element, x, y);
    this.xcomp = x;
    this.ycomp = y;
    this.offset = this.cumulativeOffset(element);

    return (y >= this.offset[1] &&
            y <  this.offset[1] + element.offsetHeight &&
            x >= this.offset[0] &&
            x <  this.offset[0] + element.offsetWidth);
  },

  withinIncludingScrolloffsets: function(element, x, y) {
    var offsetcache = this.realOffset(element);

    this.xcomp = x + offsetcache[0] - this.deltaX;
    this.ycomp = y + offsetcache[1] - this.deltaY;
    this.offset = this.cumulativeOffset(element);

    return (this.ycomp >= this.offset[1] &&
            this.ycomp <  this.offset[1] + element.offsetHeight &&
            this.xcomp >= this.offset[0] &&
            this.xcomp <  this.offset[0] + element.offsetWidth);
  },

  // within must be called directly before
  overlap: function(mode, element) {
    if (!!mode) return 0;
    if (mode == ''vertical'')
      return ((this.offset[1] + element.offsetHeight) - this.ycomp) /
        element.offsetHeight;
    if (mode == ''horizontal'')
      return ((this.offset[0] + element.offsetWidth) - this.xcomp) /
        element.offsetWidth;
  },

  clone: function(source, target) {
    source = $(source);
    target = $(target);
    target.style.position = ''absolute'';
    var offsets = this.cumulativeOffset(source);
    target.style.top    = offsets[1] + ''px'';
    target.style.left   = offsets[0] + ''px'';
    target.style.width  = source.offsetWidth + ''px'';
    target.style.height = source.offsetHeight + ''px'';
  },

  page: function(forElement) {
    var valueT = 0, valueL = 0;

    var element = forElement;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;

      // Safari fix
      if (element.offsetParent==document.body)
        if (Element.getStyle(element,''position'')==''absolute'') break;

    } while (element = element.offsetParent);

    element = forElement;
    do {
      valueT -= element.scrollTop  || 0;
      valueL -= element.scrollLeft || 0;
    } while (element = element.parentNode);

    return [valueL, valueT];
  },

  clone: function(source, target) {
    var options = Object.extend({
      setLeft:    true,
      setTop:     true,
      setWidth:   true,
      setHeight:  true,
      offsetTop:  0,
      offsetLeft: 0
    }, arguments[2] || {})

    // find page position of source
    source = $(source);
    var p = Position.page(source);

    // find coordinate system to use
    target = $(target);
    var delta = [0, 0];
    var parent = null;
    // delta [0,0] will do fine with position: fixed elements,
    // position:absolute needs offsetParent deltas
    if (Element.getStyle(target,''position'') == ''absolute'') {
      parent = Position.offsetParent(target);
      delta = Position.page(parent);
    }

    // correct by body offsets (fixes Safari)
    if (parent == document.body) {
      delta[0] -= document.body.offsetLeft;
      delta[1] -= document.body.offsetTop;
    }

    // set position
    if(options.setLeft)   target.style.left  = (p[0] - delta[0] + options.offsetLeft) + ''px'';
    if(options.setTop)    target.style.top   = (p[1] - delta[1] + options.offsetTop) + ''px'';
    if(options.setWidth)  target.style.width = source.offsetWidth + ''px'';
    if(options.setHeight) target.style.height = source.offsetHeight + ''px'';
  },

  absolutize: function(element) {
    element = $(element);
    if (element.style.position == ''absolute'') return;
    Position.prepare();

    var offsets = Position.positionedOffset(element);
    var top     = offsets[1];
    var left    = offsets[0];
    var width   = element.clientWidth;
    var height  = element.clientHeight;

    element._originalLeft   = left - parseFloat(element.style.left  || 0);
    element._originalTop    = top  - parseFloat(element.style.top || 0);
    element._originalWidth  = element.style.width;
    element._originalHeight = element.style.height;

    element.style.position = ''absolute'';
    element.style.top    = top + ''px'';;
    element.style.left   = left + ''px'';;
    element.style.width  = width + ''px'';;
    element.style.height = height + ''px'';;
  },

  relativize: function(element) {
    element = $(element);
    if (element.style.position == ''relative'') return;
    Position.prepare();

    element.style.position = ''relative'';
    var top  = parseFloat(element.style.top  || 0) - (element._originalTop || 0);
    var left = parseFloat(element.style.left || 0) - (element._originalLeft || 0);

    element.style.top    = top + ''px'';
    element.style.left   = left + ''px'';
    element.style.height = element._originalHeight;
    element.style.width  = element._originalWidth;
  }
}

// Safari returns margins on body which is incorrect if the child is absolutely
// positioned.  For performance reasons, redefine Position.cumulativeOffset for
// KHTML/WebKit only.
if (/Konqueror|Safari|KHTML/.test(navigator.userAgent)) {
  Position.cumulativeOffset = function(element) {
    var valueT = 0, valueL = 0;
    do {
      valueT += element.offsetTop  || 0;
      valueL += element.offsetLeft || 0;
      if (element.offsetParent == document.body)
        if (Element.getStyle(element, ''position'') == ''absolute'') break;

      element = element.offsetParent;
    } while (element);

    return [valueL, valueT];
  }
}'! !

!SUScriptLibrary methodsFor: 'scriptaculous' stamp: 'lr 2/22/2006 22:56'!
bBuilder
	^ '// Copyright (c) 2005 Thomas Fuchs (http://script.aculo.us, http://mir.aculo.us)
//
// See scriptaculous.js for full license.

var Builder = {
  NODEMAP: {
    AREA: ''map'',
    CAPTION: ''table'',
    COL: ''table'',
    COLGROUP: ''table'',
    LEGEND: ''fieldset'',
    OPTGROUP: ''select'',
    OPTION: ''select'',
    PARAM: ''object'',
    TBODY: ''table'',
    TD: ''table'',
    TFOOT: ''table'',
    TH: ''table'',
    THEAD: ''table'',
    TR: ''table''
  },
  // note: For Firefox < 1.5, OPTION and OPTGROUP tags are currently broken,
  //       due to a Firefox bug
  node: function(elementName) {
    elementName = elementName.toUpperCase();
    
    // try innerHTML approach
    var parentTag = this.NODEMAP[elementName] || ''div'';
    var parentElement = document.createElement(parentTag);
    try { // prevent IE "feature": http://dev.rubyonrails.org/ticket/2707
      parentElement.innerHTML = "<" + elementName + "></" + elementName + ">";
    } catch(e) {}
    var element = parentElement.firstChild || null;
      
    // see if browser added wrapping tags
    if(element && (element.tagName !!= elementName))
      element = element.getElementsByTagName(elementName)[0];
    
    // fallback to createElement approach
    if(!!element) element = document.createElement(elementName);
    
    // abort if nothing could be created
    if(!!element) return;

    // attributes (or text)
    if(arguments[1])
      if(this._isStringOrNumber(arguments[1]) ||
        (arguments[1] instanceof Array)) {
          this._children(element, arguments[1]);
        } else {
          var attrs = this._attributes(arguments[1]);
          if(attrs.length) {
            try { // prevent IE "feature": http://dev.rubyonrails.org/ticket/2707
              parentElement.innerHTML = "<" +elementName + " " +
                attrs + "></" + elementName + ">";
            } catch(e) {}
            element = parentElement.firstChild || null;
            // workaround firefox 1.0.X bug
            if(!!element) {
              element = document.createElement(elementName);
              for(attr in arguments[1]) 
                element[attr == ''class'' ? ''className'' : attr] = arguments[1][attr];
            }
            if(element.tagName !!= elementName)
              element = parentElement.getElementsByTagName(elementName)[0];
            }
        } 

    // text, or array of children
    if(arguments[2])
      this._children(element, arguments[2]);

     return element;
  },
  _text: function(text) {
     return document.createTextNode(text);
  },
  _attributes: function(attributes) {
    var attrs = [];
    for(attribute in attributes)
      attrs.push((attribute==''className'' ? ''class'' : attribute) +
          ''="'' + attributes[attribute].toString().escapeHTML() + ''"'');
    return attrs.join(" ");
  },
  _children: function(element, children) {
    if(typeof children==''object'') { // array can hold nodes and text
      children.flatten().each( function(e) {
        if(typeof e==''object'')
          element.appendChild(e)
        else
          if(Builder._isStringOrNumber(e))
            element.appendChild(Builder._text(e));
      });
    } else
      if(Builder._isStringOrNumber(children)) 
         element.appendChild(Builder._text(children));
  },
  _isStringOrNumber: function(param) {
    return(typeof param==''string'' || typeof param==''number'');
  }
}'! !

!SUScriptLibrary methodsFor: 'scriptaculous' stamp: 'lr 2/22/2006 22:58'!
cEffects
	^ '// Copyright (c) 2005 Thomas Fuchs (http://script.aculo.us, http://mir.aculo.us)
// Contributors:
//  Justin Palmer (http://encytemedia.com/)
//  Mark Pilgrim (http://diveintomark.org/)
//  Martin Bialasinki
// 
// See scriptaculous.js for full license.  

/* ------------- element ext -------------- */  
 
// converts rgb() and #xxx to #xxxxxx format,  
// returns self (or first argument) if not convertable  
String.prototype.parseColor = function() {  
  var color = ''#'';  
  if(this.slice(0,4) == ''rgb('') {  
    var cols = this.slice(4,this.length-1).split('','');  
    var i=0; do { color += parseInt(cols[i]).toColorPart() } while (++i<3);  
  } else {  
    if(this.slice(0,1) == ''#'') {  
      if(this.length==4) for(var i=1;i<4;i++) color += (this.charAt(i) + this.charAt(i)).toLowerCase();  
      if(this.length==7) color = this.toLowerCase();  
    }  
  }  
  return(color.length==7 ? color : (arguments[0] || this));  
}

Element.collectTextNodes = function(element) {  
  return $A($(element).childNodes).collect( function(node) {
    return (node.nodeType==3 ? node.nodeValue : 
      (node.hasChildNodes() ? Element.collectTextNodes(node) : ''''));
  }).flatten().join('''');
}

Element.collectTextNodesIgnoreClass = function(element, className) {  
  return $A($(element).childNodes).collect( function(node) {
    return (node.nodeType==3 ? node.nodeValue : 
      ((node.hasChildNodes() && !!Element.hasClassName(node,className)) ? 
        Element.collectTextNodesIgnoreClass(node, className) : ''''));
  }).flatten().join('''');
}

Element.setStyle = function(element, style) {
  element = $(element);
  for(k in style) element.style[k.camelize()] = style[k];
}

Element.setContentZoom = function(element, percent) {  
  Element.setStyle(element, {fontSize: (percent/100) + ''em''});   
  if(navigator.appVersion.indexOf(''AppleWebKit'')>0) window.scrollBy(0,0);  
}

Element.getOpacity = function(element){  
  var opacity;
  if (opacity = Element.getStyle(element, ''opacity''))  
    return parseFloat(opacity);  
  if (opacity = (Element.getStyle(element, ''filter'') || '''').match(/alpha\(opacity=(.*)\)/))  
    if(opacity[1]) return parseFloat(opacity[1]) / 100;  
  return 1.0;  
}

Element.setOpacity = function(element, value){  
  element= $(element);  
  if (value == 1){
    Element.setStyle(element, { opacity: 
      (/Gecko/.test(navigator.userAgent) && !!/Konqueror|Safari|KHTML/.test(navigator.userAgent)) ? 
      0.999999 : null });
    if(/MSIE/.test(navigator.userAgent))  
      Element.setStyle(element, {filter: Element.getStyle(element,''filter'').replace(/alpha\([^\)]*\)/gi,'''')});  
  } else {  
    if(value < 0.00001) value = 0;  
    Element.setStyle(element, {opacity: value});
    if(/MSIE/.test(navigator.userAgent))  
     Element.setStyle(element, 
       { filter: Element.getStyle(element,''filter'').replace(/alpha\([^\)]*\)/gi,'''') +
                 ''alpha(opacity=''+value*100+'')'' });  
  }   
}  
 
Element.getInlineOpacity = function(element){  
  return $(element).style.opacity || '''';
}  

Element.childrenWithClassName = function(element, className) {  
  return $A($(element).getElementsByTagName(''*'')).select(
    function(c) { return Element.hasClassName(c, className) });
}

Array.prototype.call = function() {
  var args = arguments;
  this.each(function(f){ f.apply(this, args) });
}

/*--------------------------------------------------------------------------*/

var Effect = {
  tagifyText: function(element) {
    var tagifyStyle = ''position:relative'';
    if(/MSIE/.test(navigator.userAgent)) tagifyStyle += '';zoom:1'';
    element = $(element);
    $A(element.childNodes).each( function(child) {
      if(child.nodeType==3) {
        child.nodeValue.toArray().each( function(character) {
          element.insertBefore(
            Builder.node(''span'',{style: tagifyStyle},
              character == '' '' ? String.fromCharCode(160) : character), 
              child);
        });
        Element.remove(child);
      }
    });
  },
  multiple: function(element, effect) {
    var elements;
    if(((typeof element == ''object'') || 
        (typeof element == ''function'')) && 
       (element.length))
      elements = element;
    else
      elements = $(element).childNodes;
      
    var options = Object.extend({
      speed: 0.1,
      delay: 0.0
    }, arguments[2] || {});
    var masterDelay = options.delay;

    $A(elements).each( function(element, index) {
      new effect(element, Object.extend(options, { delay: index * options.speed + masterDelay }));
    });
  },
  PAIRS: {
    ''slide'':  [''SlideDown'',''SlideUp''],
    ''blind'':  [''BlindDown'',''BlindUp''],
    ''appear'': [''Appear'',''Fade'']
  },
  toggle: function(element, effect) {
    element = $(element);
    effect = (effect || ''appear'').toLowerCase();
    var options = Object.extend({
      queue: { position:''end'', scope:(element.id || ''global''), limit: 1 }
    }, arguments[2] || {});
    Effect[Element.visible(element) ? 
      Effect.PAIRS[effect][1] : Effect.PAIRS[effect][0]](element, options);
  }
};

var Effect2 = Effect; // deprecated

/* ------------- transitions ------------- */

Effect.Transitions = {}

Effect.Transitions.linear = function(pos) {
  return pos;
}
Effect.Transitions.sinoidal = function(pos) {
  return (-Math.cos(pos*Math.PI)/2) + 0.5;
}
Effect.Transitions.reverse  = function(pos) {
  return 1-pos;
}
Effect.Transitions.flicker = function(pos) {
  return ((-Math.cos(pos*Math.PI)/4) + 0.75) + Math.random()/4;
}
Effect.Transitions.wobble = function(pos) {
  return (-Math.cos(pos*Math.PI*(9*pos))/2) + 0.5;
}
Effect.Transitions.pulse = function(pos) {
  return (Math.floor(pos*10) % 2 == 0 ? 
    (pos*10-Math.floor(pos*10)) : 1-(pos*10-Math.floor(pos*10)));
}
Effect.Transitions.none = function(pos) {
  return 0;
}
Effect.Transitions.full = function(pos) {
  return 1;
}

/* ------------- core effects ------------- */

Effect.ScopedQueue = Class.create();
Object.extend(Object.extend(Effect.ScopedQueue.prototype, Enumerable), {
  initialize: function() {
    this.effects  = [];
    this.interval = null;
  },
  _each: function(iterator) {
    this.effects._each(iterator);
  },
  add: function(effect) {
    var timestamp = new Date().getTime();
    
    var position = (typeof effect.options.queue == ''string'') ? 
      effect.options.queue : effect.options.queue.position;
    
    switch(position) {
      case ''front'':
        // move unstarted effects after this effect  
        this.effects.findAll(function(e){ return e.state==''idle'' }).each( function(e) {
            e.startOn  += effect.finishOn;
            e.finishOn += effect.finishOn;
          });
        break;
      case ''end'':
        // start effect after last queued effect has finished
        timestamp = this.effects.pluck(''finishOn'').max() || timestamp;
        break;
    }
    
    effect.startOn  += timestamp;
    effect.finishOn += timestamp;

    if(!!effect.options.queue.limit || (this.effects.length < effect.options.queue.limit))
      this.effects.push(effect);
    
    if(!!this.interval) 
      this.interval = setInterval(this.loop.bind(this), 40);
  },
  remove: function(effect) {
    this.effects = this.effects.reject(function(e) { return e==effect });
    if(this.effects.length == 0) {
      clearInterval(this.interval);
      this.interval = null;
    }
  },
  loop: function() {
    var timePos = new Date().getTime();
    this.effects.invoke(''loop'', timePos);
  }
});

Effect.Queues = {
  instances: $H(),
  get: function(queueName) {
    if(typeof queueName !!= ''string'') return queueName;
    
    if(!!this.instances[queueName])
      this.instances[queueName] = new Effect.ScopedQueue();
      
    return this.instances[queueName];
  }
}
Effect.Queue = Effect.Queues.get(''global'');

Effect.DefaultOptions = {
  transition: Effect.Transitions.sinoidal,
  duration:   1.0,   // seconds
  fps:        25.0,  // max. 25fps due to Effect.Queue implementation
  sync:       false, // true for combining
  from:       0.0,
  to:         1.0,
  delay:      0.0,
  queue:      ''parallel''
}

Effect.Base = function() {};
Effect.Base.prototype = {
  position: null,
  start: function(options) {
    this.options      = Object.extend(Object.extend({},Effect.DefaultOptions), options || {});
    this.currentFrame = 0;
    this.state        = ''idle'';
    this.startOn      = this.options.delay*1000;
    this.finishOn     = this.startOn + (this.options.duration*1000);
    this.event(''beforeStart'');
    if(!!this.options.sync)
      Effect.Queues.get(typeof this.options.queue == ''string'' ? 
        ''global'' : this.options.queue.scope).add(this);
  },
  loop: function(timePos) {
    if(timePos >= this.startOn) {
      if(timePos >= this.finishOn) {
        this.render(1.0);
        this.cancel();
        this.event(''beforeFinish'');
        if(this.finish) this.finish(); 
        this.event(''afterFinish'');
        return;  
      }
      var pos   = (timePos - this.startOn) / (this.finishOn - this.startOn);
      var frame = Math.round(pos * this.options.fps * this.options.duration);
      if(frame > this.currentFrame) {
        this.render(pos);
        this.currentFrame = frame;
      }
    }
  },
  render: function(pos) {
    if(this.state == ''idle'') {
      this.state = ''running'';
      this.event(''beforeSetup'');
      if(this.setup) this.setup();
      this.event(''afterSetup'');
    }
    if(this.state == ''running'') {
      if(this.options.transition) pos = this.options.transition(pos);
      pos *= (this.options.to-this.options.from);
      pos += this.options.from;
      this.position = pos;
      this.event(''beforeUpdate'');
      if(this.update) this.update(pos);
      this.event(''afterUpdate'');
    }
  },
  cancel: function() {
    if(!!this.options.sync)
      Effect.Queues.get(typeof this.options.queue == ''string'' ? 
        ''global'' : this.options.queue.scope).remove(this);
    this.state = ''finished'';
  },
  event: function(eventName) {
    if(this.options[eventName + ''Internal'']) this.options[eventName + ''Internal''](this);
    if(this.options[eventName]) this.options[eventName](this);
  },
  inspect: function() {
    return ''#<Effect:'' + $H(this).inspect() + '',options:'' + $H(this.options).inspect() + ''>'';
  }
}

Effect.Parallel = Class.create();
Object.extend(Object.extend(Effect.Parallel.prototype, Effect.Base.prototype), {
  initialize: function(effects) {
    this.effects = effects || [];
    this.start(arguments[1]);
  },
  update: function(position) {
    this.effects.invoke(''render'', position);
  },
  finish: function(position) {
    this.effects.each( function(effect) {
      effect.render(1.0);
      effect.cancel();
      effect.event(''beforeFinish'');
      if(effect.finish) effect.finish(position);
      effect.event(''afterFinish'');
    });
  }
});

Effect.Opacity = Class.create();
Object.extend(Object.extend(Effect.Opacity.prototype, Effect.Base.prototype), {
  initialize: function(element) {
    this.element = $(element);
    // make this work on IE on elements without ''layout''
    if(/MSIE/.test(navigator.userAgent) && (!!this.element.hasLayout))
      Element.setStyle(this.element, {zoom: 1});
    var options = Object.extend({
      from: Element.getOpacity(this.element) || 0.0,
      to:   1.0
    }, arguments[1] || {});
    this.start(options);
  },
  update: function(position) {
    Element.setOpacity(this.element, position);
  }
});

Effect.Move = Class.create();
Object.extend(Object.extend(Effect.Move.prototype, Effect.Base.prototype), {
  initialize: function(element) {
    this.element = $(element);
    var options = Object.extend({
      x:    0,
      y:    0,
      mode: ''relative''
    }, arguments[1] || {});
    this.start(options);
  },
  setup: function() {
    // Bug in Opera: Opera returns the "real" position of a static element or
    // relative element that does not have top/left explicitly set.
    // ==> Always set top and left for position relative elements in your stylesheets 
    // (to 0 if you do not need them) 
    Element.makePositioned(this.element);
    this.originalLeft = parseFloat(Element.getStyle(this.element,''left'') || ''0'');
    this.originalTop  = parseFloat(Element.getStyle(this.element,''top'')  || ''0'');
    if(this.options.mode == ''absolute'') {
      // absolute movement, so we need to calc deltaX and deltaY
      this.options.x = this.options.x - this.originalLeft;
      this.options.y = this.options.y - this.originalTop;
    }
  },
  update: function(position) {
    Element.setStyle(this.element, {
      left: this.options.x  * position + this.originalLeft + ''px'',
      top:  this.options.y  * position + this.originalTop  + ''px''
    });
  }
});

// for backwards compatibility
Effect.MoveBy = function(element, toTop, toLeft) {
  return new Effect.Move(element, 
    Object.extend({ x: toLeft, y: toTop }, arguments[3] || {}));
};

Effect.Scale = Class.create();
Object.extend(Object.extend(Effect.Scale.prototype, Effect.Base.prototype), {
  initialize: function(element, percent) {
    this.element = $(element)
    var options = Object.extend({
      scaleX: true,
      scaleY: true,
      scaleContent: true,
      scaleFromCenter: false,
      scaleMode: ''box'',        // ''box'' or ''contents'' or {} with provided values
      scaleFrom: 100.0,
      scaleTo:   percent
    }, arguments[2] || {});
    this.start(options);
  },
  setup: function() {
    this.restoreAfterFinish = this.options.restoreAfterFinish || false;
    this.elementPositioning = Element.getStyle(this.element,''position'');
    
    this.originalStyle = {};
    [''top'',''left'',''width'',''height'',''fontSize''].each( function(k) {
      this.originalStyle[k] = this.element.style[k];
    }.bind(this));
      
    this.originalTop  = this.element.offsetTop;
    this.originalLeft = this.element.offsetLeft;
    
    var fontSize = Element.getStyle(this.element,''font-size'') || ''100%'';
    [''em'',''px'',''%''].each( function(fontSizeType) {
      if(fontSize.indexOf(fontSizeType)>0) {
        this.fontSize     = parseFloat(fontSize);
        this.fontSizeType = fontSizeType;
      }
    }.bind(this));
    
    this.factor = (this.options.scaleTo - this.options.scaleFrom)/100;
    
    this.dims = null;
    if(this.options.scaleMode==''box'')
      this.dims = [this.element.offsetHeight, this.element.offsetWidth];
    if(/^content/.test(this.options.scaleMode))
      this.dims = [this.element.scrollHeight, this.element.scrollWidth];
    if(!!this.dims)
      this.dims = [this.options.scaleMode.originalHeight,
                   this.options.scaleMode.originalWidth];
  },
  update: function(position) {
    var currentScale = (this.options.scaleFrom/100.0) + (this.factor * position);
    if(this.options.scaleContent && this.fontSize)
      Element.setStyle(this.element, {fontSize: this.fontSize * currentScale + this.fontSizeType });
    this.setDimensions(this.dims[0] * currentScale, this.dims[1] * currentScale);
  },
  finish: function(position) {
    if (this.restoreAfterFinish) Element.setStyle(this.element, this.originalStyle);
  },
  setDimensions: function(height, width) {
    var d = {};
    if(this.options.scaleX) d.width = width + ''px'';
    if(this.options.scaleY) d.height = height + ''px'';
    if(this.options.scaleFromCenter) {
      var topd  = (height - this.dims[0])/2;
      var leftd = (width  - this.dims[1])/2;
      if(this.elementPositioning == ''absolute'') {
        if(this.options.scaleY) d.top = this.originalTop-topd + ''px'';
        if(this.options.scaleX) d.left = this.originalLeft-leftd + ''px'';
      } else {
        if(this.options.scaleY) d.top = -topd + ''px'';
        if(this.options.scaleX) d.left = -leftd + ''px'';
      }
    }
    Element.setStyle(this.element, d);
  }
});

Effect.Highlight = Class.create();
Object.extend(Object.extend(Effect.Highlight.prototype, Effect.Base.prototype), {
  initialize: function(element) {
    this.element = $(element);
    var options = Object.extend({ startcolor: ''#ffff99'' }, arguments[1] || {});
    this.start(options);
  },
  setup: function() {
    // Prevent executing on elements not in the layout flow
    if(Element.getStyle(this.element, ''display'')==''none'') { this.cancel(); return; }
    // Disable background image during the effect
    this.oldStyle = {
      backgroundImage: Element.getStyle(this.element, ''background-image'') };
    Element.setStyle(this.element, {backgroundImage: ''none''});
    if(!!this.options.endcolor)
      this.options.endcolor = Element.getStyle(this.element, ''background-color'').parseColor(''#ffffff'');
    if(!!this.options.restorecolor)
      this.options.restorecolor = Element.getStyle(this.element, ''background-color'');
    // init color calculations
    this._base  = $R(0,2).map(function(i){ return parseInt(this.options.startcolor.slice(i*2+1,i*2+3),16) }.bind(this));
    this._delta = $R(0,2).map(function(i){ return parseInt(this.options.endcolor.slice(i*2+1,i*2+3),16)-this._base[i] }.bind(this));
  },
  update: function(position) {
    Element.setStyle(this.element,{backgroundColor: $R(0,2).inject(''#'',function(m,v,i){
      return m+(Math.round(this._base[i]+(this._delta[i]*position)).toColorPart()); }.bind(this)) });
  },
  finish: function() {
    Element.setStyle(this.element, Object.extend(this.oldStyle, {
      backgroundColor: this.options.restorecolor
    }));
  }
});

Effect.ScrollTo = Class.create();
Object.extend(Object.extend(Effect.ScrollTo.prototype, Effect.Base.prototype), {
  initialize: function(element) {
    this.element = $(element);
    this.start(arguments[1] || {});
  },
  setup: function() {
    Position.prepare();
    var offsets = Position.cumulativeOffset(this.element);
    if(this.options.offset) offsets[1] += this.options.offset;
    var max = window.innerHeight ? 
      window.height - window.innerHeight :
      document.body.scrollHeight - 
        (document.documentElement.clientHeight ? 
          document.documentElement.clientHeight : document.body.clientHeight);
    this.scrollStart = Position.deltaY;
    this.delta = (offsets[1] > max ? max : offsets[1]) - this.scrollStart;
  },
  update: function(position) {
    Position.prepare();
    window.scrollTo(Position.deltaX, 
      this.scrollStart + (position*this.delta));
  }
});

/* ------------- combination effects ------------- */

Effect.Fade = function(element) {
  var oldOpacity = Element.getInlineOpacity(element);
  var options = Object.extend({
  from: Element.getOpacity(element) || 1.0,
  to:   0.0,
  afterFinishInternal: function(effect) { with(Element) { 
    if(effect.options.to!!=0) return;
    hide(effect.element);
    setStyle(effect.element, {opacity: oldOpacity}); }}
  }, arguments[1] || {});
  return new Effect.Opacity(element,options);
}

Effect.Appear = function(element) {
  var options = Object.extend({
  from: (Element.getStyle(element, ''display'') == ''none'' ? 0.0 : Element.getOpacity(element) || 0.0),
  to:   1.0,
  beforeSetup: function(effect) { with(Element) {
    setOpacity(effect.element, effect.options.from);
    show(effect.element); }}
  }, arguments[1] || {});
  return new Effect.Opacity(element,options);
}

Effect.Puff = function(element) {
  element = $(element);
  var oldStyle = { opacity: Element.getInlineOpacity(element), position: Element.getStyle(element, ''position'') };
  return new Effect.Parallel(
   [ new Effect.Scale(element, 200, 
      { sync: true, scaleFromCenter: true, scaleContent: true, restoreAfterFinish: true }), 
     new Effect.Opacity(element, { sync: true, to: 0.0 } ) ], 
     Object.extend({ duration: 1.0, 
      beforeSetupInternal: function(effect) { with(Element) {
        setStyle(effect.effects[0].element, {position: ''absolute''}); }},
      afterFinishInternal: function(effect) { with(Element) {
         hide(effect.effects[0].element);
         setStyle(effect.effects[0].element, oldStyle); }}
     }, arguments[1] || {})
   );
}

Effect.BlindUp = function(element) {
  element = $(element);
  Element.makeClipping(element);
  return new Effect.Scale(element, 0, 
    Object.extend({ scaleContent: false, 
      scaleX: false, 
      restoreAfterFinish: true,
      afterFinishInternal: function(effect) { with(Element) {
        [hide, undoClipping].call(effect.element); }} 
    }, arguments[1] || {})
  );
}

Effect.BlindDown = function(element) {
  element = $(element);
  var oldHeight = Element.getStyle(element, ''height'');
  var elementDimensions = Element.getDimensions(element);
  return new Effect.Scale(element, 100, 
    Object.extend({ scaleContent: false, 
      scaleX: false,
      scaleFrom: 0,
      scaleMode: {originalHeight: elementDimensions.height, originalWidth: elementDimensions.width},
      restoreAfterFinish: true,
      afterSetup: function(effect) { with(Element) {
        makeClipping(effect.element);
        setStyle(effect.element, {height: ''0px''});
        show(effect.element); 
      }},  
      afterFinishInternal: function(effect) { with(Element) {
        undoClipping(effect.element);
        setStyle(effect.element, {height: oldHeight});
      }}
    }, arguments[1] || {})
  );
}

Effect.SwitchOff = function(element) {
  element = $(element);
  var oldOpacity = Element.getInlineOpacity(element);
  return new Effect.Appear(element, { 
    duration: 0.4,
    from: 0,
    transition: Effect.Transitions.flicker,
    afterFinishInternal: function(effect) {
      new Effect.Scale(effect.element, 1, { 
        duration: 0.3, scaleFromCenter: true,
        scaleX: false, scaleContent: false, restoreAfterFinish: true,
        beforeSetup: function(effect) { with(Element) {
          [makePositioned,makeClipping].call(effect.element);
        }},
        afterFinishInternal: function(effect) { with(Element) {
          [hide,undoClipping,undoPositioned].call(effect.element);
          setStyle(effect.element, {opacity: oldOpacity});
        }}
      })
    }
  });
}

Effect.DropOut = function(element) {
  element = $(element);
  var oldStyle = {
    top: Element.getStyle(element, ''top''),
    left: Element.getStyle(element, ''left''),
    opacity: Element.getInlineOpacity(element) };
  return new Effect.Parallel(
    [ new Effect.Move(element, {x: 0, y: 100, sync: true }), 
      new Effect.Opacity(element, { sync: true, to: 0.0 }) ],
    Object.extend(
      { duration: 0.5,
        beforeSetup: function(effect) { with(Element) {
          makePositioned(effect.effects[0].element); }},
        afterFinishInternal: function(effect) { with(Element) {
          [hide, undoPositioned].call(effect.effects[0].element);
          setStyle(effect.effects[0].element, oldStyle); }} 
      }, arguments[1] || {}));
}

Effect.Shake = function(element) {
  element = $(element);
  var oldStyle = {
    top: Element.getStyle(element, ''top''),
    left: Element.getStyle(element, ''left'') };
	  return new Effect.Move(element, 
	    { x:  20, y: 0, duration: 0.05, afterFinishInternal: function(effect) {
	  new Effect.Move(effect.element,
	    { x: -40, y: 0, duration: 0.1,  afterFinishInternal: function(effect) {
	  new Effect.Move(effect.element,
	    { x:  40, y: 0, duration: 0.1,  afterFinishInternal: function(effect) {
	  new Effect.Move(effect.element,
	    { x: -40, y: 0, duration: 0.1,  afterFinishInternal: function(effect) {
	  new Effect.Move(effect.element,
	    { x:  40, y: 0, duration: 0.1,  afterFinishInternal: function(effect) {
	  new Effect.Move(effect.element,
	    { x: -20, y: 0, duration: 0.05, afterFinishInternal: function(effect) { with(Element) {
        undoPositioned(effect.element);
        setStyle(effect.element, oldStyle);
  }}}) }}) }}) }}) }}) }});
}

Effect.SlideDown = function(element) {
  element = $(element);
  Element.cleanWhitespace(element);
  // SlideDown need to have the content of the element wrapped in a container element with fixed height!!
  var oldInnerBottom = Element.getStyle(element.firstChild, ''bottom'');
  var elementDimensions = Element.getDimensions(element);
  return new Effect.Scale(element, 100, Object.extend({ 
    scaleContent: false, 
    scaleX: false, 
    scaleFrom: 0,
    scaleMode: {originalHeight: elementDimensions.height, originalWidth: elementDimensions.width},
    restoreAfterFinish: true,
    afterSetup: function(effect) { with(Element) {
      makePositioned(effect.element);
      makePositioned(effect.element.firstChild);
      if(window.opera) setStyle(effect.element, {top: ''''});
      makeClipping(effect.element);
      setStyle(effect.element, {height: ''0px''});
      show(element); }},
    afterUpdateInternal: function(effect) { with(Element) {
      setStyle(effect.element.firstChild, {bottom:
        (effect.dims[0] - effect.element.clientHeight) + ''px'' }); }},
    afterFinishInternal: function(effect) { with(Element) {
      undoClipping(effect.element); 
      // IE will crash if child is undoPositioned first
      if(/MSIE/.test(navigator.userAgent)){
        undoPositioned(effect.element);
        undoPositioned(effect.element.firstChild);
      }else{
        undoPositioned(effect.element.firstChild);
        undoPositioned(effect.element);
      }
      setStyle(effect.element.firstChild, {bottom: oldInnerBottom}); }}
    }, arguments[1] || {})
  );
}
  
Effect.SlideUp = function(element) {
  element = $(element);
  Element.cleanWhitespace(element);
  var oldInnerBottom = Element.getStyle(element.firstChild, ''bottom'');
  return new Effect.Scale(element, 0, 
   Object.extend({ scaleContent: false, 
    scaleX: false, 
    scaleMode: ''box'',
    scaleFrom: 100,
    restoreAfterFinish: true,
    beforeStartInternal: function(effect) { with(Element) {
      makePositioned(effect.element);
      makePositioned(effect.element.firstChild);
      if(window.opera) setStyle(effect.element, {top: ''''});
      makeClipping(effect.element);
      show(element); }},  
    afterUpdateInternal: function(effect) { with(Element) {
      setStyle(effect.element.firstChild, {bottom:
        (effect.dims[0] - effect.element.clientHeight) + ''px'' }); }},
    afterFinishInternal: function(effect) { with(Element) {
        [hide, undoClipping].call(effect.element); 
        undoPositioned(effect.element.firstChild);
        undoPositioned(effect.element);
        setStyle(effect.element.firstChild, {bottom: oldInnerBottom}); }}
   }, arguments[1] || {})
  );
}

// Bug in opera makes the TD containing this element expand for a instance after finish 
Effect.Squish = function(element) {
  return new Effect.Scale(element, window.opera ? 1 : 0, 
    { restoreAfterFinish: true,
      beforeSetup: function(effect) { with(Element) {
        makeClipping(effect.element); }},  
      afterFinishInternal: function(effect) { with(Element) {
        hide(effect.element); 
        undoClipping(effect.element); }}
  });
}

Effect.Grow = function(element) {
  element = $(element);
  var options = Object.extend({
    direction: ''center'',
    moveTransition: Effect.Transitions.sinoidal,
    scaleTransition: Effect.Transitions.sinoidal,
    opacityTransition: Effect.Transitions.full
  }, arguments[1] || {});
  var oldStyle = {
    top: element.style.top,
    left: element.style.left,
    height: element.style.height,
    width: element.style.width,
    opacity: Element.getInlineOpacity(element) };

  var dims = Element.getDimensions(element);    
  var initialMoveX, initialMoveY;
  var moveX, moveY;
  
  switch (options.direction) {
    case ''top-left'':
      initialMoveX = initialMoveY = moveX = moveY = 0; 
      break;
    case ''top-right'':
      initialMoveX = dims.width;
      initialMoveY = moveY = 0;
      moveX = -dims.width;
      break;
    case ''bottom-left'':
      initialMoveX = moveX = 0;
      initialMoveY = dims.height;
      moveY = -dims.height;
      break;
    case ''bottom-right'':
      initialMoveX = dims.width;
      initialMoveY = dims.height;
      moveX = -dims.width;
      moveY = -dims.height;
      break;
    case ''center'':
      initialMoveX = dims.width / 2;
      initialMoveY = dims.height / 2;
      moveX = -dims.width / 2;
      moveY = -dims.height / 2;
      break;
  }
  
  return new Effect.Move(element, {
    x: initialMoveX,
    y: initialMoveY,
    duration: 0.01, 
    beforeSetup: function(effect) { with(Element) {
      hide(effect.element);
      makeClipping(effect.element);
      makePositioned(effect.element);
    }},
    afterFinishInternal: function(effect) {
      new Effect.Parallel(
        [ new Effect.Opacity(effect.element, { sync: true, to: 1.0, from: 0.0, transition: options.opacityTransition }),
          new Effect.Move(effect.element, { x: moveX, y: moveY, sync: true, transition: options.moveTransition }),
          new Effect.Scale(effect.element, 100, {
            scaleMode: { originalHeight: dims.height, originalWidth: dims.width }, 
            sync: true, scaleFrom: window.opera ? 1 : 0, transition: options.scaleTransition, restoreAfterFinish: true})
        ], Object.extend({
             beforeSetup: function(effect) { with(Element) {
               setStyle(effect.effects[0].element, {height: ''0px''});
               show(effect.effects[0].element); }},
             afterFinishInternal: function(effect) { with(Element) {
               [undoClipping, undoPositioned].call(effect.effects[0].element); 
               setStyle(effect.effects[0].element, oldStyle); }}
           }, options)
      )
    }
  });
}

Effect.Shrink = function(element) {
  element = $(element);
  var options = Object.extend({
    direction: ''center'',
    moveTransition: Effect.Transitions.sinoidal,
    scaleTransition: Effect.Transitions.sinoidal,
    opacityTransition: Effect.Transitions.none
  }, arguments[1] || {});
  var oldStyle = {
    top: element.style.top,
    left: element.style.left,
    height: element.style.height,
    width: element.style.width,
    opacity: Element.getInlineOpacity(element) };

  var dims = Element.getDimensions(element);
  var moveX, moveY;
  
  switch (options.direction) {
    case ''top-left'':
      moveX = moveY = 0;
      break;
    case ''top-right'':
      moveX = dims.width;
      moveY = 0;
      break;
    case ''bottom-left'':
      moveX = 0;
      moveY = dims.height;
      break;
    case ''bottom-right'':
      moveX = dims.width;
      moveY = dims.height;
      break;
    case ''center'':  
      moveX = dims.width / 2;
      moveY = dims.height / 2;
      break;
  }
  
  return new Effect.Parallel(
    [ new Effect.Opacity(element, { sync: true, to: 0.0, from: 1.0, transition: options.opacityTransition }),
      new Effect.Scale(element, window.opera ? 1 : 0, { sync: true, transition: options.scaleTransition, restoreAfterFinish: true}),
      new Effect.Move(element, { x: moveX, y: moveY, sync: true, transition: options.moveTransition })
    ], Object.extend({            
         beforeStartInternal: function(effect) { with(Element) {
           [makePositioned, makeClipping].call(effect.effects[0].element) }},
         afterFinishInternal: function(effect) { with(Element) {
           [hide, undoClipping, undoPositioned].call(effect.effects[0].element);
           setStyle(effect.effects[0].element, oldStyle); }}
       }, options)
  );
}

Effect.Pulsate = function(element) {
  element = $(element);
  var options    = arguments[1] || {};
  var oldOpacity = Element.getInlineOpacity(element);
  var transition = options.transition || Effect.Transitions.sinoidal;
  var reverser   = function(pos){ return transition(1-Effect.Transitions.pulse(pos)) };
  reverser.bind(transition);
  return new Effect.Opacity(element, 
    Object.extend(Object.extend({  duration: 3.0, from: 0,
      afterFinishInternal: function(effect) { Element.setStyle(effect.element, {opacity: oldOpacity}); }
    }, options), {transition: reverser}));
}

Effect.Fold = function(element) {
  element = $(element);
  var oldStyle = {
    top: element.style.top,
    left: element.style.left,
    width: element.style.width,
    height: element.style.height };
  Element.makeClipping(element);
  return new Effect.Scale(element, 5, Object.extend({   
    scaleContent: false,
    scaleX: false,
    afterFinishInternal: function(effect) {
    new Effect.Scale(element, 1, { 
      scaleContent: false, 
      scaleY: false,
      afterFinishInternal: function(effect) { with(Element) {
        [hide, undoClipping].call(effect.element); 
        setStyle(effect.element, oldStyle);
      }} });
  }}, arguments[1] || {}));
}'! !

!SUScriptLibrary methodsFor: 'scriptaculous' stamp: 'lr 2/22/2006 22:59'!
dDragDrop
	^ '// Copyright (c) 2005 Thomas Fuchs (http://script.aculo.us, http://mir.aculo.us)
// 
// See scriptaculous.js for full license.

/*--------------------------------------------------------------------------*/

var Droppables = {
  drops: [],

  remove: function(element) {
    this.drops = this.drops.reject(function(d) { return d.element==$(element) });
  },

  add: function(element) {
    element = $(element);
    var options = Object.extend({
      greedy:     true,
      hoverclass: null  
    }, arguments[1] || {});

    // cache containers
    if(options.containment) {
      options._containers = [];
      var containment = options.containment;
      if((typeof containment == ''object'') && 
        (containment.constructor == Array)) {
        containment.each( function(c) { options._containers.push($(c)) });
      } else {
        options._containers.push($(containment));
      }
    }
    
    if(options.accept) options.accept = [options.accept].flatten();

    Element.makePositioned(element); // fix IE
    options.element = element;

    this.drops.push(options);
  },

  isContained: function(element, drop) {
    var parentNode = element.parentNode;
    return drop._containers.detect(function(c) { return parentNode == c });
  },

  isAffected: function(point, element, drop) {
    return (
      (drop.element!!=element) &&
      ((!!drop._containers) ||
        this.isContained(element, drop)) &&
      ((!!drop.accept) ||
        (Element.classNames(element).detect( 
          function(v) { return drop.accept.include(v) } ) )) &&
      Position.within(drop.element, point[0], point[1]) );
  },

  deactivate: function(drop) {
    if(drop.hoverclass)
      Element.removeClassName(drop.element, drop.hoverclass);
    this.last_active = null;
  },

  activate: function(drop) {
    if(drop.hoverclass)
      Element.addClassName(drop.element, drop.hoverclass);
    this.last_active = drop;
  },

  show: function(point, element) {
    if(!!this.drops.length) return;
    
    if(this.last_active) this.deactivate(this.last_active);
    this.drops.each( function(drop) {
      if(Droppables.isAffected(point, element, drop)) {
        if(drop.onHover)
           drop.onHover(element, drop.element, Position.overlap(drop.overlap, drop.element));
        if(drop.greedy) { 
          Droppables.activate(drop);
          throw $break;
        }
      }
    });
  },

  fire: function(event, element) {
    if(!!this.last_active) return;
    Position.prepare();

    if (this.isAffected([Event.pointerX(event), Event.pointerY(event)], element, this.last_active))
      if (this.last_active.onDrop) 
        this.last_active.onDrop(element, this.last_active.element, event);
  },

  reset: function() {
    if(this.last_active)
      this.deactivate(this.last_active);
  }
}

var Draggables = {
  drags: [],
  observers: [],
  
  register: function(draggable) {
    if(this.drags.length == 0) {
      this.eventMouseUp   = this.endDrag.bindAsEventListener(this);
      this.eventMouseMove = this.updateDrag.bindAsEventListener(this);
      this.eventKeypress  = this.keyPress.bindAsEventListener(this);
      
      Event.observe(document, "mouseup", this.eventMouseUp);
      Event.observe(document, "mousemove", this.eventMouseMove);
      Event.observe(document, "keypress", this.eventKeypress);
    }
    this.drags.push(draggable);
  },
  
  unregister: function(draggable) {
    this.drags = this.drags.reject(function(d) { return d==draggable });
    if(this.drags.length == 0) {
      Event.stopObserving(document, "mouseup", this.eventMouseUp);
      Event.stopObserving(document, "mousemove", this.eventMouseMove);
      Event.stopObserving(document, "keypress", this.eventKeypress);
    }
  },
  
  activate: function(draggable) {
    window.focus(); // allows keypress events if window isn''t currently focused, fails for Safari
    this.activeDraggable = draggable;
  },
  
  deactivate: function() {
    this.activeDraggable = null;
  },
  
  updateDrag: function(event) {
    if(!!this.activeDraggable) return;
    var pointer = [Event.pointerX(event), Event.pointerY(event)];
    // Mozilla-based browsers fire successive mousemove events with
    // the same coordinates, prevent needless redrawing (moz bug?)
    if(this._lastPointer && (this._lastPointer.inspect() == pointer.inspect())) return;
    this._lastPointer = pointer;
    this.activeDraggable.updateDrag(event, pointer);
  },
  
  endDrag: function(event) {
    if(!!this.activeDraggable) return;
    this._lastPointer = null;
    this.activeDraggable.endDrag(event);
    this.activeDraggable = null;
  },
  
  keyPress: function(event) {
    if(this.activeDraggable)
      this.activeDraggable.keyPress(event);
  },
  
  addObserver: function(observer) {
    this.observers.push(observer);
    this._cacheObserverCallbacks();
  },
  
  removeObserver: function(element) {  // element instead of observer fixes mem leaks
    this.observers = this.observers.reject( function(o) { return o.element==element });
    this._cacheObserverCallbacks();
  },
  
  notify: function(eventName, draggable, event) {  // ''onStart'', ''onEnd'', ''onDrag''
    if(this[eventName+''Count''] > 0)
      this.observers.each( function(o) {
        if(o[eventName]) o[eventName](eventName, draggable, event);
      });
  },
  
  _cacheObserverCallbacks: function() {
    [''onStart'',''onEnd'',''onDrag''].each( function(eventName) {
      Draggables[eventName+''Count''] = Draggables.observers.select(
        function(o) { return o[eventName]; }
      ).length;
    });
  }
}

/*--------------------------------------------------------------------------*/

var Draggable = Class.create();
Draggable.prototype = {
  initialize: function(element) {
    var options = Object.extend({
      handle: false,
      starteffect: function(element) { 
        new Effect.Opacity(element, {duration:0.2, from:1.0, to:0.7}); 
      },
      reverteffect: function(element, top_offset, left_offset) {
        var dur = Math.sqrt(Math.abs(top_offset^2)+Math.abs(left_offset^2))*0.02;
        element._revert = new Effect.Move(element, { x: -left_offset, y: -top_offset, duration: dur});
      },
      endeffect: function(element) { 
        new Effect.Opacity(element, {duration:0.2, from:0.7, to:1.0}); 
      },
      zindex: 1000,
      revert: false,
      scroll: false,
      scrollSensitivity: 20,
      scrollSpeed: 15,
      snap: false   // false, or xy or [x,y] or function(x,y){ return [x,y] }
    }, arguments[1] || {});

    this.element = $(element);
    
    if(options.handle && (typeof options.handle == ''string''))
      this.handle = Element.childrenWithClassName(this.element, options.handle)[0];  
    if(!!this.handle) this.handle = $(options.handle);
    if(!!this.handle) this.handle = this.element;
    
    if(options.scroll) options.scroll = $(options.scroll);

    Element.makePositioned(this.element); // fix IE    

    this.delta    = this.currentDelta();
    this.options  = options;
    this.dragging = false;   

    this.eventMouseDown = this.initDrag.bindAsEventListener(this);
    Event.observe(this.handle, "mousedown", this.eventMouseDown);
    
    Draggables.register(this);
  },
  
  destroy: function() {
    Event.stopObserving(this.handle, "mousedown", this.eventMouseDown);
    Draggables.unregister(this);
  },
  
  currentDelta: function() {
    return([
      parseInt(Element.getStyle(this.element,''left'') || ''0''),
      parseInt(Element.getStyle(this.element,''top'') || ''0'')]);
  },
  
  initDrag: function(event) {
    if(Event.isLeftClick(event)) {    
      // abort on form elements, fixes a Firefox issue
      var src = Event.element(event);
      if(src.tagName && (
        src.tagName==''INPUT'' ||
        src.tagName==''SELECT'' ||
        src.tagName==''OPTION'' ||
        src.tagName==''BUTTON'' ||
        src.tagName==''TEXTAREA'')) return;
        
      if(this.element._revert) {
        this.element._revert.cancel();
        this.element._revert = null;
      }
      
      var pointer = [Event.pointerX(event), Event.pointerY(event)];
      var pos     = Position.cumulativeOffset(this.element);
      this.offset = [0,1].map( function(i) { return (pointer[i] - pos[i]) });
      
      Draggables.activate(this);
      Event.stop(event);
    }
  },
  
  startDrag: function(event) {
    this.dragging = true;
    
    if(this.options.zindex) {
      this.originalZ = parseInt(Element.getStyle(this.element,''z-index'') || 0);
      this.element.style.zIndex = this.options.zindex;
    }
    
    if(this.options.ghosting) {
      this._clone = this.element.cloneNode(true);
      Position.absolutize(this.element);
      this.element.parentNode.insertBefore(this._clone, this.element);
    }
    
    if(this.options.scroll) {
      this.originalScrollLeft = this.options.scroll.scrollLeft;
      this.originalScrollTop = this.options.scroll.scrollTop;
    }
    
    Draggables.notify(''onStart'', this, event);
    if(this.options.starteffect) this.options.starteffect(this.element);
  },
  
  updateDrag: function(event, pointer) {
    if(!!this.dragging) this.startDrag(event);
    Position.prepare();
    Droppables.show(pointer, this.element);
    Draggables.notify(''onDrag'', this, event);
    this.draw(pointer);
    if(this.options.change) this.options.change(this);
    
    if(this.options.scroll) {
      //if(this.scrollInterval) this.scroll();
      this.stopScrolling();
      var p = Position.page(this.options.scroll);
      p[0] += this.options.scroll.scrollLeft;
      p[1] += this.options.scroll.scrollTop;
      p.push(p[0]+this.options.scroll.offsetWidth);
      p.push(p[1]+this.options.scroll.offsetHeight);
      var speed = [0,0];
      if(pointer[0] < (p[0]+this.options.scrollSensitivity)) speed[0] = pointer[0]-(p[0]+this.options.scrollSensitivity);
      if(pointer[1] < (p[1]+this.options.scrollSensitivity)) speed[1] = pointer[1]-(p[1]+this.options.scrollSensitivity);
      if(pointer[0] > (p[2]-this.options.scrollSensitivity)) speed[0] = pointer[0]-(p[2]-this.options.scrollSensitivity);
      if(pointer[1] > (p[3]-this.options.scrollSensitivity)) speed[1] = pointer[1]-(p[3]-this.options.scrollSensitivity);
      this.startScrolling(speed);
    }
    
    // fix AppleWebKit rendering
    if(navigator.appVersion.indexOf(''AppleWebKit'')>0) window.scrollBy(0,0);
    
    Event.stop(event);
  },
  
  finishDrag: function(event, success) {
    this.dragging = false;

    if(this.options.ghosting) {
      Position.relativize(this.element);
      Element.remove(this._clone);
      this._clone = null;
    }

    if(success) Droppables.fire(event, this.element);
    Draggables.notify(''onEnd'', this, event);

    var revert = this.options.revert;
    if(revert && typeof revert == ''function'') revert = revert(this.element);
    
    var d = this.currentDelta();
    if(revert && this.options.reverteffect) {
      this.options.reverteffect(this.element, 
        d[1]-this.delta[1], d[0]-this.delta[0]);
    } else {
      this.delta = d;
    }

    if(this.options.zindex)
      this.element.style.zIndex = this.originalZ;

    if(this.options.endeffect) 
      this.options.endeffect(this.element);

    Draggables.deactivate(this);
    Droppables.reset();
  },
  
  keyPress: function(event) {
    if(!!event.keyCode==Event.KEY_ESC) return;
    this.finishDrag(event, false);
    Event.stop(event);
  },
  
  endDrag: function(event) {
    if(!!this.dragging) return;
    this.stopScrolling();
    this.finishDrag(event, true);
    Event.stop(event);
  },
  
  draw: function(point) {
    var pos = Position.cumulativeOffset(this.element);
    var d = this.currentDelta();
    pos[0] -= d[0]; pos[1] -= d[1];
    
    if(this.options.scroll) {
      pos[0] -= this.options.scroll.scrollLeft-this.originalScrollLeft;
      pos[1] -= this.options.scroll.scrollTop-this.originalScrollTop;
    }
    
    var p = [0,1].map(function(i){ 
      return (point[i]-pos[i]-this.offset[i]) 
    }.bind(this));
    
    if(this.options.snap) {
      if(typeof this.options.snap == ''function'') {
        p = this.options.snap(p[0],p[1]);
      } else {
      if(this.options.snap instanceof Array) {
        p = p.map( function(v, i) {
          return Math.round(v/this.options.snap[i])*this.options.snap[i] }.bind(this))
      } else {
        p = p.map( function(v) {
          return Math.round(v/this.options.snap)*this.options.snap }.bind(this))
      }
    }}
    
    var style = this.element.style;
    if((!!this.options.constraint) || (this.options.constraint==''horizontal''))
      style.left = p[0] + "px";
    if((!!this.options.constraint) || (this.options.constraint==''vertical''))
      style.top  = p[1] + "px";
    if(style.visibility=="hidden") style.visibility = ""; // fix gecko rendering
  },
  
  stopScrolling: function() {
    if(this.scrollInterval) {
      clearInterval(this.scrollInterval);
      this.scrollInterval = null;
    }
  },
  
  startScrolling: function(speed) {
    this.scrollSpeed = [speed[0]*this.options.scrollSpeed,speed[1]*this.options.scrollSpeed];
    this.lastScrolled = new Date();
    this.scrollInterval = setInterval(this.scroll.bind(this), 10);
  },
  
  scroll: function() {
    var current = new Date();
    var delta = current - this.lastScrolled;
    this.lastScrolled = current;
    this.options.scroll.scrollLeft += this.scrollSpeed[0] * delta / 1000;
    this.options.scroll.scrollTop  += this.scrollSpeed[1] * delta / 1000;
    
    Position.prepare();
    Droppables.show(Draggables._lastPointer, this.element);
    Draggables.notify(''onDrag'', this);
    this.draw(Draggables._lastPointer);    
    
    if(this.options.change) this.options.change(this);
  }
}

/*--------------------------------------------------------------------------*/

var SortableObserver = Class.create();
SortableObserver.prototype = {
  initialize: function(element, observer) {
    this.element   = $(element);
    this.observer  = observer;
    this.lastValue = Sortable.serialize(this.element);
  },
  
  onStart: function() {
    this.lastValue = Sortable.serialize(this.element);
  },
  
  onEnd: function() {
    Sortable.unmark();
    if(this.lastValue !!= Sortable.serialize(this.element))
      this.observer(this.element)
  }
}

var Sortable = {
  sortables: new Array(),
  
  options: function(element){
    element = $(element);
    return this.sortables.detect(function(s) { return s.element == element });
  },
  
  destroy: function(element){
    element = $(element);
    this.sortables.findAll(function(s) { return s.element == element }).each(function(s){
      Draggables.removeObserver(s.element);
      s.droppables.each(function(d){ Droppables.remove(d) });
      s.draggables.invoke(''destroy'');
    });
    this.sortables = this.sortables.reject(function(s) { return s.element == element });
  },
  
  create: function(element) {
    element = $(element);
    var options = Object.extend({ 
      element:     element,
      tag:         ''li'',       // assumes li children, override with tag: ''tagname''
      dropOnEmpty: false,
      tree:        false,      // fixme: unimplemented
      overlap:     ''vertical'', // one of ''vertical'', ''horizontal''
      constraint:  ''vertical'', // one of ''vertical'', ''horizontal'', false
      containment: element,    // also takes array of elements (or id''s); or false
      handle:      false,      // or a CSS class
      only:        false,
      hoverclass:  null,
      ghosting:    false,
      scroll:      false,
      format:      null,
      onChange:    Prototype.emptyFunction,
      onUpdate:    Prototype.emptyFunction
    }, arguments[1] || {});

    // clear any old sortable with same element
    this.destroy(element);

    // build options for the draggables
    var options_for_draggable = {
      revert:      true,
      scroll:      options.scroll,
      ghosting:    options.ghosting,
      constraint:  options.constraint,
      handle:      options.handle };

    if(options.starteffect)
      options_for_draggable.starteffect = options.starteffect;

    if(options.reverteffect)
      options_for_draggable.reverteffect = options.reverteffect;
    else
      if(options.ghosting) options_for_draggable.reverteffect = function(element) {
        element.style.top  = 0;
        element.style.left = 0;
      };

    if(options.endeffect)
      options_for_draggable.endeffect = options.endeffect;

    if(options.zindex)
      options_for_draggable.zindex = options.zindex;

    // build options for the droppables  
    var options_for_droppable = {
      overlap:     options.overlap,
      containment: options.containment,
      hoverclass:  options.hoverclass,
      onHover:     Sortable.onHover,
      greedy:      !!options.dropOnEmpty
    }

    // fix for gecko engine
    Element.cleanWhitespace(element); 

    options.draggables = [];
    options.droppables = [];

    // make it so

    // drop on empty handling
    if(options.dropOnEmpty) {
      Droppables.add(element,
        {containment: options.containment, onHover: Sortable.onEmptyHover, greedy: false});
      options.droppables.push(element);
    }

    (this.findElements(element, options) || []).each( function(e) {
      // handles are per-draggable
      var handle = options.handle ? 
        Element.childrenWithClassName(e, options.handle)[0] : e;    
      options.draggables.push(
        new Draggable(e, Object.extend(options_for_draggable, { handle: handle })));
      Droppables.add(e, options_for_droppable);
      options.droppables.push(e);      
    });

    // keep reference
    this.sortables.push(options);

    // for onupdate
    Draggables.addObserver(new SortableObserver(element, options.onUpdate));

  },

  // return all suitable-for-sortable elements in a guaranteed order
  findElements: function(element, options) {
    if(!!element.hasChildNodes()) return null;
    var elements = [];
    $A(element.childNodes).each( function(e) {
      if(e.tagName && e.tagName.toUpperCase()==options.tag.toUpperCase() &&
        (!!options.only || (Element.hasClassName(e, options.only))))
          elements.push(e);
      if(options.tree) {
        var grandchildren = this.findElements(e, options);
        if(grandchildren) elements.push(grandchildren);
      }
    });

    return (elements.length>0 ? elements.flatten() : null);
  },

  onHover: function(element, dropon, overlap) {
    if(overlap>0.5) {
      Sortable.mark(dropon, ''before'');
      if(dropon.previousSibling !!= element) {
        var oldParentNode = element.parentNode;
        element.style.visibility = "hidden"; // fix gecko rendering
        dropon.parentNode.insertBefore(element, dropon);
        if(dropon.parentNode!!=oldParentNode) 
          Sortable.options(oldParentNode).onChange(element);
        Sortable.options(dropon.parentNode).onChange(element);
      }
    } else {
      Sortable.mark(dropon, ''after'');
      var nextElement = dropon.nextSibling || null;
      if(nextElement !!= element) {
        var oldParentNode = element.parentNode;
        element.style.visibility = "hidden"; // fix gecko rendering
        dropon.parentNode.insertBefore(element, nextElement);
        if(dropon.parentNode!!=oldParentNode) 
          Sortable.options(oldParentNode).onChange(element);
        Sortable.options(dropon.parentNode).onChange(element);
      }
    }
  },

  onEmptyHover: function(element, dropon) {
    if(element.parentNode!!=dropon) {
      var oldParentNode = element.parentNode;
      dropon.appendChild(element);
      Sortable.options(oldParentNode).onChange(element);
      Sortable.options(dropon).onChange(element);
    }
  },

  unmark: function() {
    if(Sortable._marker) Element.hide(Sortable._marker);
  },

  mark: function(dropon, position) {
    // mark on ghosting only
    var sortable = Sortable.options(dropon.parentNode);
    if(sortable && !!sortable.ghosting) return; 

    if(!!Sortable._marker) {
      Sortable._marker = $(''dropmarker'') || document.createElement(''DIV'');
      Element.hide(Sortable._marker);
      Element.addClassName(Sortable._marker, ''dropmarker'');
      Sortable._marker.style.position = ''absolute'';
      document.getElementsByTagName("body").item(0).appendChild(Sortable._marker);
    }    
    var offsets = Position.cumulativeOffset(dropon);
    Sortable._marker.style.left = offsets[0] + ''px'';
    Sortable._marker.style.top = offsets[1] + ''px'';
    
    if(position==''after'')
      if(sortable.overlap == ''horizontal'') 
        Sortable._marker.style.left = (offsets[0]+dropon.clientWidth) + ''px'';
      else
        Sortable._marker.style.top = (offsets[1]+dropon.clientHeight) + ''px'';
    
    Element.show(Sortable._marker);
  },

  sequence: function(element) {
    element = $(element);
    var sortableOptions = this.options(element);
    var options = Object.extend({
      tag:  sortableOptions.tag,
      only: sortableOptions.only,
      name: element.id,
      format: sortableOptions.format || /^[^_]*_(.*)$/
    }, arguments[1] || {});
    return $(this.findElements(element, options) || []).map( function(item) {
      return item.id.match(options.format) ? item.id.match(options.format)[1] : '''';
    });
  },

  serialize: function(element) {
    element = $(element);
    return Sortable.sequence(element, arguments[1]).map( function(item) {
      return encodeURIComponent(element.id) + "[]=" + encodeURIComponent(item);
    }).join(''&'');
  }
}'! !

!SUScriptLibrary methodsFor: 'scriptaculous' stamp: 'lr 2/22/2006 22:59'!
eControls
	^ '// Copyright (c) 2005 Thomas Fuchs (http://script.aculo.us, http://mir.aculo.us)
//           (c) 2005 Ivan Krstic (http://blogs.law.harvard.edu/ivan)
//           (c) 2005 Jon Tirsen (http://www.tirsen.com)
// Contributors:
//  Richard Livsey
//  Rahul Bhargava
//  Rob Wills
// 
// See scriptaculous.js for full license.

// Autocompleter.Base handles all the autocompletion functionality 
// that''s independent of the data source for autocompletion. This
// includes drawing the autocompletion menu, observing keyboard
// and mouse events, and similar.
//
// Specific autocompleters need to provide, at the very least, 
// a getUpdatedChoices function that will be invoked every time
// the text inside the monitored textbox changes. This method 
// should get the text for which to provide autocompletion by
// invoking this.getToken(), NOT by directly accessing
// this.element.value. This is to allow incremental tokenized
// autocompletion. Specific auto-completion logic (AJAX, etc)
// belongs in getUpdatedChoices.
//
// Tokenized incremental autocompletion is enabled automatically
// when an autocompleter is instantiated with the ''tokens'' option
// in the options parameter, e.g.:
// new Ajax.Autocompleter(''id'',''upd'', ''/url/'', { tokens: '','' });
// will incrementally autocomplete with a comma as the token.
// Additionally, '','' in the above example can be replaced with
// a token array, e.g. { tokens: ['','', ''\n''] } which
// enables autocompletion on multiple tokens. This is most 
// useful when one of the tokens is \n (a newline), as it 
// allows smart autocompletion after linebreaks.

var Autocompleter = {}
Autocompleter.Base = function() {};
Autocompleter.Base.prototype = {
  baseInitialize: function(element, update, options) {
    this.element     = $(element); 
    this.update      = $(update);  
    this.hasFocus    = false; 
    this.changed     = false; 
    this.active      = false; 
    this.index       = 0;     
    this.entryCount  = 0;

    if (this.setOptions)
      this.setOptions(options);
    else
      this.options = options || {};

    this.options.paramName    = this.options.paramName || this.element.name;
    this.options.tokens       = this.options.tokens || [];
    this.options.frequency    = this.options.frequency || 0.4;
    this.options.minChars     = this.options.minChars || 1;
    this.options.onShow       = this.options.onShow || 
    function(element, update){ 
      if(!!update.style.position || update.style.position==''absolute'') {
        update.style.position = ''absolute'';
        Position.clone(element, update, {setHeight: false, offsetTop: element.offsetHeight});
      }
      Effect.Appear(update,{duration:0.15});
    };
    this.options.onHide = this.options.onHide || 
    function(element, update){ new Effect.Fade(update,{duration:0.15}) };

    if (typeof(this.options.tokens) == ''string'') 
      this.options.tokens = new Array(this.options.tokens);

    this.observer = null;
    
    this.element.setAttribute(''autocomplete'',''off'');

    Element.hide(this.update);

    Event.observe(this.element, "blur", this.onBlur.bindAsEventListener(this));
    Event.observe(this.element, "keypress", this.onKeyPress.bindAsEventListener(this));
  },

  show: function() {
    if(Element.getStyle(this.update, ''display'')==''none'') this.options.onShow(this.element, this.update);
    if(!!this.iefix && 
      (navigator.appVersion.indexOf(''MSIE'')>0) &&
      (navigator.userAgent.indexOf(''Opera'')<0) &&
      (Element.getStyle(this.update, ''position'')==''absolute'')) {
      new Insertion.After(this.update, 
       ''<iframe id="'' + this.update.id + ''_iefix" ''+
       ''style="display:none;position:absolute;filter:progid:DXImageTransform.Microsoft.Alpha(opacity=0);" '' +
       ''src="javascript:false;" frameborder="0" scrolling="no"></iframe>'');
      this.iefix = $(this.update.id+''_iefix'');
    }
    if(this.iefix) setTimeout(this.fixIEOverlapping.bind(this), 50);
  },
  
  fixIEOverlapping: function() {
    Position.clone(this.update, this.iefix);
    this.iefix.style.zIndex = 1;
    this.update.style.zIndex = 2;
    Element.show(this.iefix);
  },

  hide: function() {
    this.stopIndicator();
    if(Element.getStyle(this.update, ''display'')!!=''none'') this.options.onHide(this.element, this.update);
    if(this.iefix) Element.hide(this.iefix);
  },

  startIndicator: function() {
    if(this.options.indicator) Element.show(this.options.indicator);
  },

  stopIndicator: function() {
    if(this.options.indicator) Element.hide(this.options.indicator);
  },

  onKeyPress: function(event) {
    if(this.active)
      switch(event.keyCode) {
       case Event.KEY_TAB:
       case Event.KEY_RETURN:
         this.selectEntry();
         Event.stop(event);
       case Event.KEY_ESC:
         this.hide();
         this.active = false;
         Event.stop(event);
         return;
       case Event.KEY_LEFT:
       case Event.KEY_RIGHT:
         return;
       case Event.KEY_UP:
         this.markPrevious();
         this.render();
         if(navigator.appVersion.indexOf(''AppleWebKit'')>0) Event.stop(event);
         return;
       case Event.KEY_DOWN:
         this.markNext();
         this.render();
         if(navigator.appVersion.indexOf(''AppleWebKit'')>0) Event.stop(event);
         return;
      }
     else 
      if(event.keyCode==Event.KEY_TAB || event.keyCode==Event.KEY_RETURN) 
        return;

    this.changed = true;
    this.hasFocus = true;

    if(this.observer) clearTimeout(this.observer);
      this.observer = 
        setTimeout(this.onObserverEvent.bind(this), this.options.frequency*1000);
  },

  activate: function() {
    this.changed = false;
    this.hasFocus = true;
    this.getUpdatedChoices();
  },

  onHover: function(event) {
    var element = Event.findElement(event, ''LI'');
    if(this.index !!= element.autocompleteIndex) 
    {
        this.index = element.autocompleteIndex;
        this.render();
    }
    Event.stop(event);
  },
  
  onClick: function(event) {
    var element = Event.findElement(event, ''LI'');
    this.index = element.autocompleteIndex;
    this.selectEntry();
    this.hide();
  },
  
  onBlur: function(event) {
    // needed to make click events working
    setTimeout(this.hide.bind(this), 250);
    this.hasFocus = false;
    this.active = false;     
  }, 
  
  render: function() {
    if(this.entryCount > 0) {
      for (var i = 0; i < this.entryCount; i++)
        this.index==i ? 
          Element.addClassName(this.getEntry(i),"selected") : 
          Element.removeClassName(this.getEntry(i),"selected");
        
      if(this.hasFocus) { 
        this.show();
        this.active = true;
      }
    } else {
      this.active = false;
      this.hide();
    }
  },
  
  markPrevious: function() {
    if(this.index > 0) this.index--
      else this.index = this.entryCount-1;
  },
  
  markNext: function() {
    if(this.index < this.entryCount-1) this.index++
      else this.index = 0;
  },
  
  getEntry: function(index) {
    return this.update.firstChild.childNodes[index];
  },
  
  getCurrentEntry: function() {
    return this.getEntry(this.index);
  },
  
  selectEntry: function() {
    this.active = false;
    this.updateElement(this.getCurrentEntry());
  },

  updateElement: function(selectedElement) {
    if (this.options.updateElement) {
      this.options.updateElement(selectedElement);
      return;
    }
    var value = '''';
    if (this.options.select) {
      var nodes = document.getElementsByClassName(this.options.select, selectedElement) || [];
      if(nodes.length>0) value = Element.collectTextNodes(nodes[0], this.options.select);
    } else
      value = Element.collectTextNodesIgnoreClass(selectedElement, ''informal'');
    
    var lastTokenPos = this.findLastToken();
    if (lastTokenPos !!= -1) {
      var newValue = this.element.value.substr(0, lastTokenPos + 1);
      var whitespace = this.element.value.substr(lastTokenPos + 1).match(/^\s+/);
      if (whitespace)
        newValue += whitespace[0];
      this.element.value = newValue + value;
    } else {
      this.element.value = value;
    }
    this.element.focus();
    
    if (this.options.afterUpdateElement)
      this.options.afterUpdateElement(this.element, selectedElement);
  },

  updateChoices: function(choices) {
    if(!!this.changed && this.hasFocus) {
      this.update.innerHTML = choices;
      Element.cleanWhitespace(this.update);
      Element.cleanWhitespace(this.update.firstChild);

      if(this.update.firstChild && this.update.firstChild.childNodes) {
        this.entryCount = 
          this.update.firstChild.childNodes.length;
        for (var i = 0; i < this.entryCount; i++) {
          var entry = this.getEntry(i);
          entry.autocompleteIndex = i;
          this.addObservers(entry);
        }
      } else { 
        this.entryCount = 0;
      }

      this.stopIndicator();

      this.index = 0;
      this.render();
    }
  },

  addObservers: function(element) {
    Event.observe(element, "mouseover", this.onHover.bindAsEventListener(this));
    Event.observe(element, "click", this.onClick.bindAsEventListener(this));
  },

  onObserverEvent: function() {
    this.changed = false;   
    if(this.getToken().length>=this.options.minChars) {
      this.startIndicator();
      this.getUpdatedChoices();
    } else {
      this.active = false;
      this.hide();
    }
  },

  getToken: function() {
    var tokenPos = this.findLastToken();
    if (tokenPos !!= -1)
      var ret = this.element.value.substr(tokenPos + 1).replace(/^\s+/,'''').replace(/\s+$/,'''');
    else
      var ret = this.element.value;

    return /\n/.test(ret) ? '''' : ret;
  },

  findLastToken: function() {
    var lastTokenPos = -1;

    for (var i=0; i<this.options.tokens.length; i++) {
      var thisTokenPos = this.element.value.lastIndexOf(this.options.tokens[i]);
      if (thisTokenPos > lastTokenPos)
        lastTokenPos = thisTokenPos;
    }
    return lastTokenPos;
  }
}

Ajax.Autocompleter = Class.create();
Object.extend(Object.extend(Ajax.Autocompleter.prototype, Autocompleter.Base.prototype), {
  initialize: function(element, update, url, options) {
	  this.baseInitialize(element, update, options);
    this.options.asynchronous  = true;
    this.options.onComplete    = this.onComplete.bind(this);
    this.options.defaultParams = this.options.parameters || null;
    this.url                   = url;
  },

  getUpdatedChoices: function() {
    entry = encodeURIComponent(this.options.paramName) + ''='' + 
      encodeURIComponent(this.getToken());

    this.options.parameters = this.options.callback ?
      this.options.callback(this.element, entry) : entry;

    if(this.options.defaultParams) 
      this.options.parameters += ''&'' + this.options.defaultParams;

    new Ajax.Request(this.url, this.options);
  },

  onComplete: function(request) {
    this.updateChoices(request.responseText);
  }

});

// The local array autocompleter. Used when you''d prefer to
// inject an array of autocompletion options into the page, rather
// than sending out Ajax queries, which can be quite slow sometimes.
//
// The constructor takes four parameters. The first two are, as usual,
// the id of the monitored textbox, and id of the autocompletion menu.
// The third is the array you want to autocomplete from, and the fourth
// is the options block.
//
// Extra local autocompletion options:
// - choices - How many autocompletion choices to offer
//
// - partialSearch - If false, the autocompleter will match entered
//                    text only at the beginning of strings in the 
//                    autocomplete array. Defaults to true, which will
//                    match text at the beginning of any *word* in the
//                    strings in the autocomplete array. If you want to
//                    search anywhere in the string, additionally set
//                    the option fullSearch to true (default: off).
//
// - fullSsearch - Search anywhere in autocomplete array strings.
//
// - partialChars - How many characters to enter before triggering
//                   a partial match (unlike minChars, which defines
//                   how many characters are required to do any match
//                   at all). Defaults to 2.
//
// - ignoreCase - Whether to ignore case when autocompleting.
//                 Defaults to true.
//
// It''s possible to pass in a custom function as the ''selector'' 
// option, if you prefer to write your own autocompletion logic.
// In that case, the other options above will not apply unless
// you support them.

Autocompleter.Local = Class.create();
Autocompleter.Local.prototype = Object.extend(new Autocompleter.Base(), {
  initialize: function(element, update, array, options) {
    this.baseInitialize(element, update, options);
    this.options.array = array;
  },

  getUpdatedChoices: function() {
    this.updateChoices(this.options.selector(this));
  },

  setOptions: function(options) {
    this.options = Object.extend({
      choices: 10,
      partialSearch: true,
      partialChars: 2,
      ignoreCase: true,
      fullSearch: false,
      selector: function(instance) {
        var ret       = []; // Beginning matches
        var partial   = []; // Inside matches
        var entry     = instance.getToken();
        var count     = 0;

        for (var i = 0; i < instance.options.array.length &&  
          ret.length < instance.options.choices ; i++) { 

          var elem = instance.options.array[i];
          var foundPos = instance.options.ignoreCase ? 
            elem.toLowerCase().indexOf(entry.toLowerCase()) : 
            elem.indexOf(entry);

          while (foundPos !!= -1) {
            if (foundPos == 0 && elem.length !!= entry.length) { 
              ret.push("<li><strong>" + elem.substr(0, entry.length) + "</strong>" + 
                elem.substr(entry.length) + "</li>");
              break;
            } else if (entry.length >= instance.options.partialChars && 
              instance.options.partialSearch && foundPos !!= -1) {
              if (instance.options.fullSearch || /\s/.test(elem.substr(foundPos-1,1))) {
                partial.push("<li>" + elem.substr(0, foundPos) + "<strong>" +
                  elem.substr(foundPos, entry.length) + "</strong>" + elem.substr(
                  foundPos + entry.length) + "</li>");
                break;
              }
            }

            foundPos = instance.options.ignoreCase ? 
              elem.toLowerCase().indexOf(entry.toLowerCase(), foundPos + 1) : 
              elem.indexOf(entry, foundPos + 1);

          }
        }
        if (partial.length)
          ret = ret.concat(partial.slice(0, instance.options.choices - ret.length))
        return "<ul>" + ret.join('''') + "</ul>";
      }
    }, options || {});
  }
});

// AJAX in-place editor
//
// see documentation on http://wiki.script.aculo.us/scriptaculous/show/Ajax.InPlaceEditor

// Use this if you notice weird scrolling problems on some browsers,
// the DOM might be a bit confused when this gets called so do this
// waits 1 ms (with setTimeout) until it does the activation
Field.scrollFreeActivate = function(field) {
  setTimeout(function() {
    Field.activate(field);
  }, 1);
}

Ajax.InPlaceEditor = Class.create();
Ajax.InPlaceEditor.defaultHighlightColor = "#FFFF99";
Ajax.InPlaceEditor.prototype = {
  initialize: function(element, url, options) {
    this.url = url;
    this.element = $(element);

    this.options = Object.extend({
      okButton: true,
      okText: "ok",
      cancelLink: true,
      cancelText: "cancel",
      savingText: "Saving...",
      clickToEditText: "Click to edit",
      okText: "ok",
      rows: 1,
      onComplete: function(transport, element) {
        new Effect.Highlight(element, {startcolor: this.options.highlightcolor});
      },
      onFailure: function(transport) {
        alert("Error communicating with the server: " + transport.responseText.stripTags());
      },
      callback: function(form) {
        return Form.serialize(form);
      },
      handleLineBreaks: true,
      loadingText: ''Loading...'',
      savingClassName: ''inplaceeditor-saving'',
      loadingClassName: ''inplaceeditor-loading'',
      formClassName: ''inplaceeditor-form'',
      highlightcolor: Ajax.InPlaceEditor.defaultHighlightColor,
      highlightendcolor: "#FFFFFF",
      externalControl:	null,
      submitOnBlur: false,
      ajaxOptions: {}
    }, options || {});

    if(!!this.options.formId && this.element.id) {
      this.options.formId = this.element.id + "-inplaceeditor";
      if ($(this.options.formId)) {
        // there''s already a form with that name, don''t specify an id
        this.options.formId = null;
      }
    }
    
    if (this.options.externalControl) {
      this.options.externalControl = $(this.options.externalControl);
    }
    
    this.originalBackground = Element.getStyle(this.element, ''background-color'');
    if (!!this.originalBackground) {
      this.originalBackground = "transparent";
    }
    
    this.element.title = this.options.clickToEditText;
    
    this.onclickListener = this.enterEditMode.bindAsEventListener(this);
    this.mouseoverListener = this.enterHover.bindAsEventListener(this);
    this.mouseoutListener = this.leaveHover.bindAsEventListener(this);
    Event.observe(this.element, ''click'', this.onclickListener);
    Event.observe(this.element, ''mouseover'', this.mouseoverListener);
    Event.observe(this.element, ''mouseout'', this.mouseoutListener);
    if (this.options.externalControl) {
      Event.observe(this.options.externalControl, ''click'', this.onclickListener);
      Event.observe(this.options.externalControl, ''mouseover'', this.mouseoverListener);
      Event.observe(this.options.externalControl, ''mouseout'', this.mouseoutListener);
    }
  },
  enterEditMode: function(evt) {
    if (this.saving) return;
    if (this.editing) return;
    this.editing = true;
    this.onEnterEditMode();
    if (this.options.externalControl) {
      Element.hide(this.options.externalControl);
    }
    Element.hide(this.element);
    this.createForm();
    this.element.parentNode.insertBefore(this.form, this.element);
    Field.scrollFreeActivate(this.editField);
    // stop the event to avoid a page refresh in Safari
    if (evt) {
      Event.stop(evt);
    }
    return false;
  },
  createForm: function() {
    this.form = document.createElement("form");
    this.form.id = this.options.formId;
    Element.addClassName(this.form, this.options.formClassName)
    this.form.onsubmit = this.onSubmit.bind(this);

    this.createEditField();

    if (this.options.textarea) {
      var br = document.createElement("br");
      this.form.appendChild(br);
    }

    if (this.options.okButton) {
      okButton = document.createElement("input");
      okButton.type = "submit";
      okButton.value = this.options.okText;
      this.form.appendChild(okButton);
    }

    if (this.options.cancelLink) {
      cancelLink = document.createElement("a");
      cancelLink.href = "#";
      cancelLink.appendChild(document.createTextNode(this.options.cancelText));
      cancelLink.onclick = this.onclickCancel.bind(this);
      this.form.appendChild(cancelLink);
    }
  },
  hasHTMLLineBreaks: function(string) {
    if (!!this.options.handleLineBreaks) return false;
    return string.match(/<br/i) || string.match(/<p>/i);
  },
  convertHTMLLineBreaks: function(string) {
    return string.replace(/<br>/gi, "\n").replace(/<br\/>/gi, "\n").replace(/<\/p>/gi, "\n").replace(/<p>/gi, "");
  },
  createEditField: function() {
    var text;
    if(this.options.loadTextURL) {
      text = this.options.loadingText;
    } else {
      text = this.getText();
    }

    var obj = this;
    
    if (this.options.rows == 1 && !!this.hasHTMLLineBreaks(text)) {
      this.options.textarea = false;
      var textField = document.createElement("input");
      textField.obj = this;
      textField.type = "text";
      textField.name = "value";
      textField.value = text;
      textField.style.backgroundColor = this.options.highlightcolor;
      var size = this.options.size || this.options.cols || 0;
      if (size !!= 0) textField.size = size;
      if (this.options.submitOnBlur)
        textField.onblur = this.onSubmit.bind(this);
      this.editField = textField;
    } else {
      this.options.textarea = true;
      var textArea = document.createElement("textarea");
      textArea.obj = this;
      textArea.name = "value";
      textArea.value = this.convertHTMLLineBreaks(text);
      textArea.rows = this.options.rows;
      textArea.cols = this.options.cols || 40;
      if (this.options.submitOnBlur)
        textArea.onblur = this.onSubmit.bind(this);
      this.editField = textArea;
    }
    
    if(this.options.loadTextURL) {
      this.loadExternalText();
    }
    this.form.appendChild(this.editField);
  },
  getText: function() {
    return this.element.innerHTML;
  },
  loadExternalText: function() {
    Element.addClassName(this.form, this.options.loadingClassName);
    this.editField.disabled = true;
    new Ajax.Request(
      this.options.loadTextURL,
      Object.extend({
        asynchronous: true,
        onComplete: this.onLoadedExternalText.bind(this)
      }, this.options.ajaxOptions)
    );
  },
  onLoadedExternalText: function(transport) {
    Element.removeClassName(this.form, this.options.loadingClassName);
    this.editField.disabled = false;
    this.editField.value = transport.responseText.stripTags();
  },
  onclickCancel: function() {
    this.onComplete();
    this.leaveEditMode();
    return false;
  },
  onFailure: function(transport) {
    this.options.onFailure(transport);
    if (this.oldInnerHTML) {
      this.element.innerHTML = this.oldInnerHTML;
      this.oldInnerHTML = null;
    }
    return false;
  },
  onSubmit: function() {
    // onLoading resets these so we need to save them away for the Ajax call
    var form = this.form;
    var value = this.editField.value;
    
    // do this first, sometimes the ajax call returns before we get a chance to switch on Saving...
    // which means this will actually switch on Saving... *after* we''ve left edit mode causing Saving...
    // to be displayed indefinitely
    this.onLoading();
    
    new Ajax.Updater(
      { 
        success: this.element,
         // don''t update on failure (this could be an option)
        failure: null
      },
      this.url,
      Object.extend({
        parameters: this.options.callback(form, value),
        onComplete: this.onComplete.bind(this),
        onFailure: this.onFailure.bind(this)
      }, this.options.ajaxOptions)
    );
    // stop the event to avoid a page refresh in Safari
    if (arguments.length > 1) {
      Event.stop(arguments[0]);
    }
    return false;
  },
  onLoading: function() {
    this.saving = true;
    this.removeForm();
    this.leaveHover();
    this.showSaving();
  },
  showSaving: function() {
    this.oldInnerHTML = this.element.innerHTML;
    this.element.innerHTML = this.options.savingText;
    Element.addClassName(this.element, this.options.savingClassName);
    this.element.style.backgroundColor = this.originalBackground;
    Element.show(this.element);
  },
  removeForm: function() {
    if(this.form) {
      if (this.form.parentNode) Element.remove(this.form);
      this.form = null;
    }
  },
  enterHover: function() {
    if (this.saving) return;
    this.element.style.backgroundColor = this.options.highlightcolor;
    if (this.effect) {
      this.effect.cancel();
    }
    Element.addClassName(this.element, this.options.hoverClassName)
  },
  leaveHover: function() {
    if (this.options.backgroundColor) {
      this.element.style.backgroundColor = this.oldBackground;
    }
    Element.removeClassName(this.element, this.options.hoverClassName)
    if (this.saving) return;
    this.effect = new Effect.Highlight(this.element, {
      startcolor: this.options.highlightcolor,
      endcolor: this.options.highlightendcolor,
      restorecolor: this.originalBackground
    });
  },
  leaveEditMode: function() {
    Element.removeClassName(this.element, this.options.savingClassName);
    this.removeForm();
    this.leaveHover();
    this.element.style.backgroundColor = this.originalBackground;
    Element.show(this.element);
    if (this.options.externalControl) {
      Element.show(this.options.externalControl);
    }
    this.editing = false;
    this.saving = false;
    this.oldInnerHTML = null;
    this.onLeaveEditMode();
  },
  onComplete: function(transport) {
    this.leaveEditMode();
    this.options.onComplete.bind(this)(transport, this.element);
  },
  onEnterEditMode: function() {},
  onLeaveEditMode: function() {},
  dispose: function() {
    if (this.oldInnerHTML) {
      this.element.innerHTML = this.oldInnerHTML;
    }
    this.leaveEditMode();
    Event.stopObserving(this.element, ''click'', this.onclickListener);
    Event.stopObserving(this.element, ''mouseover'', this.mouseoverListener);
    Event.stopObserving(this.element, ''mouseout'', this.mouseoutListener);
    if (this.options.externalControl) {
      Event.stopObserving(this.options.externalControl, ''click'', this.onclickListener);
      Event.stopObserving(this.options.externalControl, ''mouseover'', this.mouseoverListener);
      Event.stopObserving(this.options.externalControl, ''mouseout'', this.mouseoutListener);
    }
  }
};

// Delayed observer, like Form.Element.Observer, 
// but waits for delay after last key input
// Ideal for live-search fields

Form.Element.DelayedObserver = Class.create();
Form.Element.DelayedObserver.prototype = {
  initialize: function(element, delay, callback) {
    this.delay     = delay || 0.5;
    this.element   = $(element);
    this.callback  = callback;
    this.timer     = null;
    this.lastValue = $F(this.element); 
    Event.observe(this.element,''keyup'',this.delayedListener.bindAsEventListener(this));
  },
  delayedListener: function(event) {
    if(this.lastValue == $F(this.element)) return;
    if(this.timer) clearTimeout(this.timer);
    this.timer = setTimeout(this.onTimerEvent.bind(this), this.delay * 1000);
    this.lastValue = $F(this.element);
  },
  onTimerEvent: function() {
    this.timer = null;
    this.callback(this.element, $F(this.element));
  }
};'! !

!SUScriptLibrary methodsFor: 'scriptaculous' stamp: 'lr 2/22/2006 22:59'!
fSlider
	^ '// Copyright (c) 2005 Marty Haught, Thomas Fuchs 
//
// See http://script.aculo.us for more info
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

if(!!Control) var Control = {};
Control.Slider = Class.create();

// options:
//  axis: ''vertical'', or ''horizontal'' (default)
//
// callbacks:
//  onChange(value)
//  onSlide(value)
Control.Slider.prototype = {
  initialize: function(handle, track, options) {
    var slider = this;
    
    if(handle instanceof Array) {
      this.handles = handle.collect( function(e) { return $(e) });
    } else {
      this.handles = [$(handle)];
    }
    
    this.track   = $(track);
    this.options = options || {};

    this.axis      = this.options.axis || ''horizontal'';
    this.increment = this.options.increment || 1;
    this.step      = parseInt(this.options.step || ''1'');
    this.range     = this.options.range || $R(0,1);
    
    this.value     = 0; // assure backwards compat
    this.values    = this.handles.map( function() { return 0 });
    this.spans     = this.options.spans ? this.options.spans.map(function(s){ return $(s) }) : false;
    this.options.startSpan = $(this.options.startSpan || null);
    this.options.endSpan   = $(this.options.endSpan || null);

    this.restricted = this.options.restricted || false;

    this.maximum   = this.options.maximum || this.range.end;
    this.minimum   = this.options.minimum || this.range.start;

    // Will be used to align the handle onto the track, if necessary
    this.alignX = parseInt(this.options.alignX || ''0'');
    this.alignY = parseInt(this.options.alignY || ''0'');
    
    this.trackLength = this.maximumOffset() - this.minimumOffset();
    this.handleLength = this.isVertical() ? this.handles[0].offsetHeight : this.handles[0].offsetWidth;

    this.active   = false;
    this.dragging = false;
    this.disabled = false;

    if(this.options.disabled) this.setDisabled();

    // Allowed values array
    this.allowedValues = this.options.values ? this.options.values.sortBy(Prototype.K) : false;
    if(this.allowedValues) {
      this.minimum = this.allowedValues.min();
      this.maximum = this.allowedValues.max();
    }

    this.eventMouseDown = this.startDrag.bindAsEventListener(this);
    this.eventMouseUp   = this.endDrag.bindAsEventListener(this);
    this.eventMouseMove = this.update.bindAsEventListener(this);

    // Initialize handles in reverse (make sure first handle is active)
    this.handles.each( function(h,i) {
      i = slider.handles.length-1-i;
      slider.setValue(parseFloat(
        (slider.options.sliderValue instanceof Array ? 
          slider.options.sliderValue[i] : slider.options.sliderValue) || 
         slider.range.start), i);
      Element.makePositioned(h); // fix IE
      Event.observe(h, "mousedown", slider.eventMouseDown);
    });
    
    Event.observe(this.track, "mousedown", this.eventMouseDown);
    Event.observe(document, "mouseup", this.eventMouseUp);
    Event.observe(document, "mousemove", this.eventMouseMove);
    
    this.initialized = true;
  },
  dispose: function() {
    var slider = this;    
    Event.stopObserving(this.track, "mousedown", this.eventMouseDown);
    Event.stopObserving(document, "mouseup", this.eventMouseUp);
    Event.stopObserving(document, "mousemove", this.eventMouseMove);
    this.handles.each( function(h) {
      Event.stopObserving(h, "mousedown", slider.eventMouseDown);
    });
  },
  setDisabled: function(){
    this.disabled = true;
  },
  setEnabled: function(){
    this.disabled = false;
  },  
  getNearestValue: function(value){
    if(this.allowedValues){
      if(value >= this.allowedValues.max()) return(this.allowedValues.max());
      if(value <= this.allowedValues.min()) return(this.allowedValues.min());
      
      var offset = Math.abs(this.allowedValues[0] - value);
      var newValue = this.allowedValues[0];
      this.allowedValues.each( function(v) {
        var currentOffset = Math.abs(v - value);
        if(currentOffset <= offset){
          newValue = v;
          offset = currentOffset;
        } 
      });
      return newValue;
    }
    if(value > this.range.end) return this.range.end;
    if(value < this.range.start) return this.range.start;
    return value;
  },
  setValue: function(sliderValue, handleIdx){
    if(!!this.active) {
      this.activeHandle    = this.handles[handleIdx];
      this.activeHandleIdx = handleIdx;
      this.updateStyles();
    }
    handleIdx = handleIdx || this.activeHandleIdx || 0;
    if(this.initialized && this.restricted) {
      if((handleIdx>0) && (sliderValue<this.values[handleIdx-1]))
        sliderValue = this.values[handleIdx-1];
      if((handleIdx < (this.handles.length-1)) && (sliderValue>this.values[handleIdx+1]))
        sliderValue = this.values[handleIdx+1];
    }
    sliderValue = this.getNearestValue(sliderValue);
    this.values[handleIdx] = sliderValue;
    this.value = this.values[0]; // assure backwards compat
    
    this.handles[handleIdx].style[this.isVertical() ? ''top'' : ''left''] = 
      this.translateToPx(sliderValue);
    
    this.drawSpans();
    if(!!this.dragging || !!this.event) this.updateFinished();
  },
  setValueBy: function(delta, handleIdx) {
    this.setValue(this.values[handleIdx || this.activeHandleIdx || 0] + delta, 
      handleIdx || this.activeHandleIdx || 0);
  },
  translateToPx: function(value) {
    return Math.round(
      ((this.trackLength-this.handleLength)/(this.range.end-this.range.start)) * 
      (value - this.range.start)) + "px";
  },
  translateToValue: function(offset) {
    return ((offset/(this.trackLength-this.handleLength) * 
      (this.range.end-this.range.start)) + this.range.start);
  },
  getRange: function(range) {
    var v = this.values.sortBy(Prototype.K); 
    range = range || 0;
    return $R(v[range],v[range+1]);
  },
  minimumOffset: function(){
    return(this.isVertical() ? this.alignY : this.alignX);
  },
  maximumOffset: function(){
    return(this.isVertical() ?
      this.track.offsetHeight - this.alignY : this.track.offsetWidth - this.alignX);
  },  
  isVertical:  function(){
    return (this.axis == ''vertical'');
  },
  drawSpans: function() {
    var slider = this;
    if(this.spans)
      $R(0, this.spans.length-1).each(function(r) { slider.setSpan(slider.spans[r], slider.getRange(r)) });
    if(this.options.startSpan)
      this.setSpan(this.options.startSpan,
        $R(0, this.values.length>1 ? this.getRange(0).min() : this.value ));
    if(this.options.endSpan)
      this.setSpan(this.options.endSpan, 
        $R(this.values.length>1 ? this.getRange(this.spans.length-1).max() : this.value, this.maximum));
  },
  setSpan: function(span, range) {
    if(this.isVertical()) {
      span.style.top = this.translateToPx(range.start);
      span.style.height = this.translateToPx(range.end - range.start);
    } else {
      span.style.left = this.translateToPx(range.start);
      span.style.width = this.translateToPx(range.end - range.start);
    }
  },
  updateStyles: function() {
    this.handles.each( function(h){ Element.removeClassName(h, ''selected'') });
    Element.addClassName(this.activeHandle, ''selected'');
  },
  startDrag: function(event) {
    if(Event.isLeftClick(event)) {
      if(!!this.disabled){
        this.active = true;
        
        var handle = Event.element(event);
        var pointer  = [Event.pointerX(event), Event.pointerY(event)];
        if(handle==this.track) {
          var offsets  = Position.cumulativeOffset(this.track); 
          this.event = event;
          this.setValue(this.translateToValue( 
           (this.isVertical() ? pointer[1]-offsets[1] : pointer[0]-offsets[0])-(this.handleLength/2)
          ));
          var offsets  = Position.cumulativeOffset(this.activeHandle);
          this.offsetX = (pointer[0] - offsets[0]);
          this.offsetY = (pointer[1] - offsets[1]);
        } else {
          // find the handle (prevents issues with Safari)
          while((this.handles.indexOf(handle) == -1) && handle.parentNode) 
            handle = handle.parentNode;
        
          this.activeHandle    = handle;
          this.activeHandleIdx = this.handles.indexOf(this.activeHandle);
          this.updateStyles();
        
          var offsets  = Position.cumulativeOffset(this.activeHandle);
          this.offsetX = (pointer[0] - offsets[0]);
          this.offsetY = (pointer[1] - offsets[1]);
        }
      }
      Event.stop(event);
    }
  },
  update: function(event) {
   if(this.active) {
      if(!!this.dragging) this.dragging = true;
      this.draw(event);
      // fix AppleWebKit rendering
      if(navigator.appVersion.indexOf(''AppleWebKit'')>0) window.scrollBy(0,0);
      Event.stop(event);
   }
  },
  draw: function(event) {
    var pointer = [Event.pointerX(event), Event.pointerY(event)];
    var offsets = Position.cumulativeOffset(this.track);
    pointer[0] -= this.offsetX + offsets[0];
    pointer[1] -= this.offsetY + offsets[1];
    this.event = event;
    this.setValue(this.translateToValue( this.isVertical() ? pointer[1] : pointer[0] ));
    if(this.initialized && this.options.onSlide)
      this.options.onSlide(this.values.length>1 ? this.values : this.value, this);
  },
  endDrag: function(event) {
    if(this.active && this.dragging) {
      this.finishDrag(event, true);
      Event.stop(event);
    }
    this.active = false;
    this.dragging = false;
  },  
  finishDrag: function(event, success) {
    this.active = false;
    this.dragging = false;
    this.updateFinished();
  },
  updateFinished: function() {
    if(this.initialized && this.options.onChange) 
      this.options.onChange(this.values.length>1 ? this.values : this.value, this);
    this.event = null;
  }
}'! !

!Collection methodsFor: '*scriptaculous' stamp: 'avi 9/27/2005 23:19'!
asJavascript
	^ String streamContents:
		[:s |
		s nextPut: $[.
		self do: [:ea | s nextPutAll: ea asJavascript] separatedBy: [s nextPutAll: ', '].
		s nextPut: $]]! !

!Point methodsFor: '*scriptaculous' stamp: 'lr 2/14/2006 16:01'!
asJavascript
	^ String streamContents: [ :stream |
		stream 
			nextPut: $[;
			nextPutAll: self x asJavascript; 
			nextPut: $,;
			nextPutAll: self y asJavascript; 
			nextPut: $] ].! !

!WATagBrush methodsFor: '*scriptaculous' stamp: 'lr 2/14/2006 17:52'!
script: aPrototype
	aPrototype attachToBrush: self on: canvas.! !

!Association methodsFor: '*scriptaculous' stamp: 'avi 9/27/2005 23:36'!
asJavascript
	^ String streamContents:
		[:s |
		s
			nextPut: $(;
			nextPutAll: self key asJavascript.
		self value ifNotNilDo:
			[:v |
			s
				nextPutAll: ' + ''='' + ';
				nextPutAll: v asJavascript].
		s nextPut: $)]! !
SUExample initialize!
SUAllTests initialize!
